﻿# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para stormtv
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
# Por JuRR
# v0.999
#------------------------------------------------------------
import urlparse,urllib2,urllib,re

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from core import servertools
import os,errno,sys,traceback
from core import stormlib
import xml.etree.ElementTree as ET
import datetime
from time import strptime
import sqlite3


__channel__ = "stormtv"
__category__ = "F,S,A"
__type__ = "generic"
__title__ = "stormtv2"
__language__ = "ES"
__server__ = "oc1.lopezepol.com"

DEBUG = config.get_setting("debug")
#PREFERENCES  =stormlib.getpreferences()
PREFERENCES  ="0"
LANG =stormlib.getlang()
SERVERS =stormlib.getservers()
SERVER = "http://"+__server__+"/stormtv/public/"
STATIC_SERVER= "http://"+__server__+"/stormtv/public/"
#ALL_SERVERS = list( set(servertools.FREE_SERVERS) | set(servertools.FILENIUM_SERVERS) | set(servertools.REALDEBRID_SERVERS) | set(servertools.ALLDEBRID_SERVERS) )
#ALL_SERVERS.sort()
DICT_SERVERS = servertools.get_servers_list()
ALL_SERVERS = DICT_SERVERS.keys()
ALL_SERVERS.sort

def isGeneric():
    return True

def searchtype(item):
	if (DEBUG): logger.info( "[stormtv.py] searchtype")
	import socket
	socket.setdefaulttimeout(10) # timeout in seconds
	itemlist = []
	itemlist.append( Item(channel=__channel__, action="search"    , thumbnail=STATIC_SERVER+"buscar.jpg", title="Buscar", url="",fanart=STATIC_SERVER+"logo.jpg"))
	itemlist.append( Item(channel=__channel__,action="newsearch",thumbnail=STATIC_SERVER+"buscar.jpg",fulltitle=" ",title="nuevaBusqueda", url="",fanart=STATIC_SERVER+"logo.jpg",extra=" ",category=" "))
	itemlist.append( Item(channel=__channel__,action="genresearch",thumbnail=STATIC_SERVER+"buscar.jpg",title="Buscar por Genero", url="",fanart=STATIC_SERVER+"logo.jpg"))
	itemlist.append( Item(channel=__channel__,action="yearsearch",thumbnail=STATIC_SERVER+"buscar.jpg",title="Buscar por Año", url="",fanart=STATIC_SERVER+"logo.jpg"))
	itemlist.append( Item(channel=__channel__,action="popular",thumbnail=STATIC_SERVER+"buscar.jpg",title="Series mas populares", url="",fanart=STATIC_SERVER+"logo.jpg"))
	itemlist.append( Item(channel=__channel__,action="recentmovies",thumbnail=STATIC_SERVER+"buscar.jpg",title="50 Ultimas peliculas", url="",fanart=STATIC_SERVER+"logo.jpg"))
	itemlist.append( Item(channel=__channel__,action="recentseries",thumbnail=STATIC_SERVER+"buscar.jpg",title="50 Ultimas series", url="",fanart=STATIC_SERVER+"logo.jpg"))
	path=config.get_data_path()+"stormtv/temp/"

	stormlib.getalltvslist()
	xml=path+"/"+"tvslists.xml"
	tvserie = ET.parse(xml)
	series=tvserie.getroot()
	
	for serie in series.findall('serie'):
		name = serie.find('name').text
		name = name.encode("utf-8")
		fanart = serie.find('fanart').text
		poster = serie.find('poster').text
		type = serie.find('type').text
		id = serie.find('id').text
		try:
			plot = serie.find('plot').text
			plot=plot.encode("utf-8")
		except:
			plot=""
		if (DEBUG): logger.info( "name:"+name+" fanart"+fanart+" poster:"+poster+" type:"+type+" plot:"+plot )
		itemlist.append( Item(channel=__channel__, action="listtvs" , title=name, fulltitle=name , url=id, thumbnail=STATIC_SERVER+poster, plot=plot, viewmode="movie", show=id, fanart=STATIC_SERVER+fanart))
	return itemlist


def newsearch(item):
	itemlist=[]
	extra=""
	fulltitle=""
	param_dict={}
	if (item.category<>" "):
		list=item.category.split(",")
		if (DEBUG): logger.info( "item.category="+item.category )
		for li in list:
			if (DEBUG): logger.info( "##li->"+li )
			elements=li.split(":")
			param_dict[elements[0]]=elements[1]
			if (DEBUG): logger.info( "###->"+elements[0]+"#"+elements[1] )
	else:
		if (DEBUG): logger.info( "kk" )
	for k in param_dict.keys():
		if (DEBUG): logger.info( "Key->"+k )
	itemlist.append( Item(channel=__channel__, action="searchgo" ,thumbnail=STATIC_SERVER+"buscar.jpg", title="Buscar "+item.fulltitle, url="",fanart=STATIC_SERVER+"logo.jpg"))
	if ("Genero" in param_dict.keys()):
		itemlist.append( Item(channel=__channel__, action="change_filter" ,thumbnail=STATIC_SERVER+"buscar.jpg", title="+ Genero:"+param_dict["Genero"], url="",fanart=STATIC_SERVER+"logo.jpg",extra=extra,fulltitle=item.fulltitle,category=item.category))
	else:
		itemlist.append( Item(channel=__channel__, action="change_filter" ,thumbnail=STATIC_SERVER+"buscar.jpg", title="+ Genero:", url="",fanart=STATIC_SERVER+"logo.jpg",extra=extra,fulltitle=item.fulltitle,category=item.category))
	if ("Anyo" in param_dict.keys()):
		itemlist.append( Item(channel=__channel__, action="change_filter" ,thumbnail=STATIC_SERVER+"buscar.jpg", title="+ Anyo:"+param_dict["Anyo"], url="",fanart=STATIC_SERVER+"logo.jpg",fulltitle=item.fulltitle,category=item.category))
	else:
		itemlist.append( Item(channel=__channel__, action="change_filter" ,thumbnail=STATIC_SERVER+"buscar.jpg", title="+ Anyo:", url="",fanart=STATIC_SERVER+"logo.jpg",fulltitle=item.fulltitle,category=item.category))
	if ("Tipo" in param_dict.keys()):
		itemlist.append( Item(channel=__channel__, action="change_filter" ,thumbnail=STATIC_SERVER+"buscar.jpg", title="+ Tipo:"+param_dict["Tipo"], url="",fanart=STATIC_SERVER+"logo.jpg",extra=extra,fulltitle=item.fulltitle,category=item.category))
	else:
		itemlist.append( Item(channel=__channel__, action="change_filter" ,thumbnail=STATIC_SERVER+"buscar.jpg", title="+ Tipo:", url="",fanart=STATIC_SERVER+"logo.jpg",fulltitle=item.fulltitle,category=item.category))
	return itemlist
	
def change_filter(item):
	if (DEBUG): logger.info( "changefilter 1"+item.fulltitle )
	extra=item.extra
	import xbmcgui
	import xml.dom.minidom as minidom
	dialog=xbmcgui.Dialog()
	if "+ Genero:" in item.title:
		path=config.get_data_path()+"stormtv/temp/"                                                                                                                               
		urllib.urlretrieve (SERVER+"tvseries/genres", path+"genres.xml")                                                                                                            
		xml=path+"/"+"genres.xml"                                                                                                                                                   
		doc = minidom.parse(xml)                                                                                                                                                  
		node = doc.documentElement                                                                                                                                                
		genres = doc.getElementsByTagName("genre")                                                                                                                                
		if (DEBUG): logger.info( len(genres))
		o_genres_id=[]
		o_genres=[]                                                                                                                                                               
		for genre in genres:                                                                                                                                                      
			name2= genre.getElementsByTagName("name")[0].childNodes[0].data                                                                                                   
			name = name2.decode("utf-8")                                                                                                                                      
			if (DEBUG): logger.info("###"+name+"$$")                                                                                                                          
			id = genre.getElementsByTagName("id")[0].childNodes[0].data
			if (DEBUG): logger.info( name+id )                                                                                                                  
			o_genres.append(name)#=["comedia", "drama", "amor"]                                                                                                                         
			o_genres_id.append(id)#=[10,24,48]                                                                                                                                  
		index=dialog.select("generos",o_genres)
		genreiii=o_genres_id[index]
		genrename=o_genres[index]
		extra="Genero:"+genrename
		if (item.fulltitle<>" "):
			fulltitle=item.fulltitle+",genre:"+genreiii
			category=item.category+",Genero:"+genrename
		else:
			fulltitle="genre:"+genreiii
			category="Genero:"+genrename
	if "+ Anyo:" in item.title:
		path=config.get_data_path()+"stormtv/temp/"                                                                                                                               
		urllib.urlretrieve (SERVER+"tvseries/years", path+"years.xml")                                                                                                            
		xml=path+"/"+"years.xml"                                                                                                                                                   
		doc = minidom.parse(xml)                                                                                                                                                  
		node = doc.documentElement                                                                                                                                                
		genres = doc.getElementsByTagName("year")                                                                                                                                
		if (DEBUG): logger.info( len(genres))                                                                                                                              
		o_genres_id=[]
		o_genres=[]                                                                                                                                                               
		for genre in genres:                                                                                                                                                      
			name2= genre.getElementsByTagName("name")[0].childNodes[0].data                                                                                                   
			name = name2.decode("utf-8")                                                                                                                                      
			if (DEBUG): logger.info("###"+name+"$$")                                                                                                                          
			id = genre.getElementsByTagName("id")[0].childNodes[0].data
			if (DEBUG): logger.info( name+id)                                                                                                                         
			o_genres.append(name)#=["comedia", "drama", "amor"]                                                                                                                         
			o_genres_id.append(id)#=[10,24,48]                                                                                                                                  
		index=dialog.select("generos",o_genres)
		genreiii=o_genres_id[index]
		anyoname=o_genres[index]
		extra="Anyo:"+anyoname
		if (item.fulltitle<>" "):
			fulltitle=item.fulltitle+",year:"+genreiii
			category=item.category+",Anyo:"+anyoname
		else:
			fulltitle="year:"+genreiii
			category="Anyo:"+anyoname
	if  "+ Tipo:" in item.title:
		o_types=["Peliculas","Series"]
		o_types_id=["1","0"]
		index=dialog.select("Tipo",o_types)
		typeiii=o_types_id[index]
		typename=o_types[index]
		extra="Tipo:"+typename
		if (item.fulltitle<>" "):
			fulltitle=item.fulltitle+",type:"+typeiii
			category=item.category+",Tipo:"+typeiii
		else:
			fulltitle="type:"+typeiii
			category="Tipo:"+typename
	if (DEBUG): logger.info( "changefilter 2"+fulltitle)
	return newsearch(Item(channel=__channel__,extra=extra,fulltitle=fulltitle,category=category))

def searchgo(item):
	param_dict={}
	itemlist=[]
	if (item.category<>" "):
		list=item.category.split(",")
		if (DEBUG): logger.info( "item.category="+item.category)
		for li in list:
			if (DEBUG): logger.info( "##li->"+li)
			elements=li.split(":")
			param_dict[elements[0]]=elements[1]
			if (DEBUG): logger.info( "###->"+elements[0]+"#"+elements[1])
	else:
		if (DEBUG): logger.info( "kk")
	for k in param_dict.keys():
		if (DEBUG): logger.info( "Key->"+k)
	
	search_str=item.fulltitle.replace(":","/")
	search_str=search_str.replace(",","/")
	search_str=search_str.replace("Buscar ","")
	if (DEBUG): logger.info( search_str)
	url=SERVER+"/tvseries/advancesearch/"+search_str
	if (DEBUG): logger.info( "Url"+url)
	path=config.get_data_path()+"stormtv/temp/"
	search = urllib2.urlopen(SERVER+"/tvseries/advancesearch/"+search_str,timeout=30)
	output = open(path+"searchresult.xml",'wb')
	output.write(search.read())
	output.close()
	xml="searchresult.xml"
	itemlist=seriesxml_toitemlist(xml,"")
	return itemlist
	
	
	
def search(item,texto, categoria="*"):
	import socket
	socket.setdefaulttimeout(10) # timeout in seconds
	logger.info("[stormtv.py] search "+texto )
	itemlist = []
	path=config.get_data_path()+"stormtv/temp/"
	remove_tempxml(path+"search")
	remove_tempxml(path+"nocatalogsearch")
	search = urllib2.urlopen(SERVER+"/tvseries/search/title/"+texto,timeout=30)
	output = open(path+"searchresult.xml",'wb')
	output.write(search.read())
	output.close()
	xml="searchresult.xml"
	itemlist=seriesxml_toitemlist(xml,"")
	itemlist.append( Item(channel=__channel__,action="",title="<-------Sin Catalogar------------>",fulltitle="",extra=texto))
	nitemlist=nocatalogsearch(Item(channel=__channel__,action="nocatalogsearch",title="<Buscar en items sin catalogar>",fulltitle="",extra=texto))
	itemlist=itemlist+nitemlist
	return itemlist

def listtvs(item):
	path=config.get_data_path()+"stormtv/temp/"
	itemlist=[]
	stormlib.gettvslist(item.show)
	xml="temp.xml"
	itemlist=seriesxml_toitemlist(xml,"search/")
	return itemlist

def popular(item):
	path=config.get_data_path()+"stormtv/temp/"
	itemlist=[]
	stormlib.getpopular()
	xml="temp.xml"
	itemlist=seriesxml_toitemlist(xml,"search/")
	return itemlist
def recentmovies(item):
	path=config.get_data_path()+"stormtv/temp/"
	itemlist=[]
	stormlib.getrecentmovies()
	xml="temp.xml"
	itemlist=seriesxml_toitemlist(xml,"search/")
	return itemlist
def recentseries(item):
	path=config.get_data_path()+"stormtv/temp/"
	itemlist=[]
	stormlib.getrecentseries()
	xml="temp.xml"
	itemlist=seriesxml_toitemlist(xml,"search/")
	return itemlist
def genresearch(item):
	user_id = config.get_setting("stormtvuser")
	user_pass = config.get_setting("stormtvpassword")
	path=config.get_data_path()+"stormtv/temp/"
	urllib.urlretrieve (SERVER+"tvseries/genres", path+"genres.xml")
	xml=path+"/"+"genres.xml"
	tvserie = ET.parse(xml)
	genres=tvserie.getroot()
	if (DEBUG): logger.info( len(genres))
	itemlist=[]
	for genre in genres.findall('genre'):
		name = genre.find('name').text
		name = name.decode("utf-8")
		if (DEBUG): logger.info("###"+name+"$$")
		id = genre.find("id").text
		itemlist.append( Item(channel=__channel__, action="genretvs" , title=name, fulltitle=name , url=id, thumbnail=STATIC_SERVER+"logo.jpg", plot="", viewmode="movie", show=id ,fanart=STATIC_SERVER+"logo.jpg"))
	return itemlist
def nocatalogsearch(item):
	path=config.get_data_path()+"stormtv/temp/"
	itemlist = []
	if (item.extra==""):
		import xbmc
		keyboard = xbmc.Keyboard("")
		keyboard.doModal()
		if (keyboard.isConfirmed()):
			texto = keyboard.getText()
		else:
			texto=""
	else:
		texto=item.extra
		logger.info("[stormtv.py] search "+texto )
		path=config.get_data_path()+"stormtv/temp/"
		if not os.path.exists(path):
			logger.info("[stormtv.py] search Creating data_path "+path)
		try:
			os.mkdirs(path)
		except:
			logger.info( "[stormtv.py] search fallo crear directorio" )
			pass
    #urllib.urlretrieve (SERVER+"/tvseries/search/title/"+texto, path+"temp.xml")
	search = urllib2.urlopen(SERVER+"/tvseries/searchnocatalog2/title/"+texto,timeout=30)
	output = open(path+"nocatalogsearch.xml",'wb')
	output.write(search.read())
	output.close()
	xml=path+"nocatalogsearch.xml"
	tvserie = ET.parse(xml)
	series=tvserie.getroot()
	itemlist=[]
	for serie in series.findall('serie'):
	   try:
		name = serie.find('name').text
		name = name.encode("utf-8")
		#if (DEBUG): logger.info( "name->"+name+"<-name")
		id = serie.find('id').text
		if (DEBUG): logger.info( "name->"+id+"<-name")
		fanart = serie.find('fanart').text
		poster = serie.find('poster').text
		type = serie.find('type').text
		channels = serie.find('channels')
		try:
			plot = serie.find('plot').text
			plot=plot.encode("utf-8")
		except:
			plot=""
		tvshow=path+"nocatalogsearch/"+id+".xml"
		if not os.path.exists(tvshow):
				tvserie2 = ET.ElementTree(serie)
				tvserie2.write(tvshow)
		
		channel=channels.find("channel")
		ch_name=channel.find("name").text
		if (type=="0"):
			itemlist.append( Item(channel=__channel__, action="conceptseason" , title=name+" "+ch_name, show=id, extra="0"))
		else:
			itemlist.append( Item(channel=__channel__, action="conceptmovie" , title=name+" "+ch_name,  show=id))
	   except:
		pass
	return itemlist

def yearsearch(item):
	user_id = config.get_setting("stormtvuser")
	user_pass = config.get_setting("stormtvpassword")
	path=config.get_data_path()+"stormtv/temp/"
	urllib.urlretrieve (SERVER+"tvseries/years", path+"years.xml")
	xml=path+"/"+"years.xml"
	tvserie = ET.parse(xml)
	years=tvserie.getroot()
	if (DEBUG): logger.info( len(years))
	itemlist=[]
	for year in years.findall('year'):
		name = year.find('name').text
		if (DEBUG): logger.info("###"+name+"$$")
		id = year.find("id").text
		itemlist.append( Item(channel=__channel__, action="yeartvs" , title=name, fulltitle=name , url=id, thumbnail=STATIC_SERVER+"logo.jpg", plot="", viewmode="movie_with_plot", show=id ,fanart=STATIC_SERVER+"logo.jpg"))
	return itemlist
def yeartvs(item):
	if (DEBUG): logger.info("[stormtv.py] yeartvs")
	user_id = config.get_setting("stormtvuser")
	user_pass = config.get_setting("stormtvpassword")
	path=config.get_data_path()+"stormtv/temp/"
	urllib.urlretrieve (SERVER+"tvseries/yeartvs/year/"+item.url, path+"yearsearchres.xml")
	xml="yearsearchres.xml"
	itemlist=[]
	itemlist=seriesxml_toitemlist(xml,"search/")
	return itemlist

def genretvs(item):
	if (DEBUG): logger.info("[stormtv.py] genretvs")
	user_id = config.get_setting("stormtvuser")
	user_pass = config.get_setting("stormtvpassword")
	path=config.get_data_path()+"stormtv/temp/"
	urllib.urlretrieve (SERVER+"tvseries/genretvs/genre/"+item.url, path+"genresearchres.xml")
	xml="genresearchres.xml"
	itemlist=[]
	itemlist=seriesxml_toitemlist(xml)
	return itemlist
##################################
# Fin de busquedas				 #
##################################
#
#  Busca las series que se han visto recientemente para crear activeseries.xml y otherfollowing.xml
#  requiere: following.xml y activefollowing.xml
#  following se obtiene de la llamada a tvseries/following 
#  activefollowing se obtiene de la llamada a chapters/getrecent
def newmainlist(item):
	if (DEBUG): logger.info("[stormtv.py] newmainlist")
	user_id = config.get_setting("stormtvuser")
	user_pass = config.get_setting("stormtvpassword")
	path=config.get_data_path()+"stormtv/temp/"
	active_xml=path+"activefollowing.xml"
	other_xml=path+"otherfollowing.xml"
	follow_xml=path+"following.xml"
	activeseries_xml=path+"activeseries.xml"
	watching_list=[]
	following_list=[]
	today=datetime.date.today()
	tvseries= ET.Element('Series')
	activeseries=ET.Element('Series')
	otherseries=ET.Element('Series')
	month_ago_date = today - datetime.timedelta(weeks=4)
	view='Mixed'
	
	urllib.urlretrieve (SERVER+"tvseries/following/user/"+user_id+"/pass/"+user_pass+"/view/"+view, path+"following.xml")
	urllib.urlretrieve (SERVER+"chapters/getrecent/user/"+user_id+"/pass/"+user_pass, active_xml)
	if (os.path.exists(active_xml)):
		tvserie = ET.parse(active_xml)
		series=tvserie.getroot()
		for serie in series.findall('serie'):
			id = serie.find('id').text
			watching_list.append(id);
	else:
		root = ET.Element('Series')
		activeseries_serie = ET.ElementTree(root)
		activeseries_serie.write(active_xml)

	if (os.path.exists(follow_xml)):
		tvserie = ET.parse(follow_xml)
		series=tvserie.getroot()
		for serie in series.findall('serie'):
			added_text = serie.find('added').text
			id = serie.find('id').text
			try:
				added_date = datetime.datetime.strptime(added_text+" 00:00", "%Y-%m-%d %M:%S")
			except:
				added_date = datetime.datetime(*(strptime(added_text+" 00:00", "%Y-%m-%d %M:%S")[0:6]))
			
			#today 2015-03-15
			#monthago 2015-02-15<2015-02-27
			
			if (month_ago_date<added_date.date())or (id in watching_list):
				#anadir elemento al otro ET.
				tvseries.append(serie)
					
			else:
				otherseries.append(serie)
				if (DEBUG): logger.info( "mas antiguo")
	tvseries_serie = ET.ElementTree(tvseries)
	tvseries_serie.write(activeseries_xml)
	otherseries_serie = ET.ElementTree(otherseries)
	otherseries_serie.write(other_xml)
			
			
def mainlist(item):
	import xbmc,sys
	if (PREFERENCES=="0"):
		user_id = config.get_setting("stormtvuser")
		user_pass = config.get_setting("stormtvpassword")
		adv = config.get_setting("stormtvadv")
		tvslang=stormlib.getverifylang()
		path=config.get_data_path()+"stormtv/temp/"
		create_directory(path)
		create_directory(path+"search")
		mkdir_p(path+"search")
		create_directory(path+"nocatalogsearch")
		mkdir_p(path+"nocatalogsearch")
		itemlist = []
		serieslist = []
		vistos=""
		total_chapter=""
		itemlist.append( Item(channel=__channel__,action="searchtype",thumbnail=STATIC_SERVER+"buscar.jpg",title="Buscar", url="",fanart=STATIC_SERVER+"logo.jpg"))
		try:
			view=item.extra
		except:
			view="Mixed"
		itemlist.append( Item(channel=__channel__,action="change_view",thumbnail=STATIC_SERVER+"vista.jpg",title="Cambiar vista",url="",fanart=STATIC_SERVER+"logo.jpg"))
		if (adv == "true"):
			itemlist.append( Item(channel=__channel__,action="new_concept",thumbnail=STATIC_SERVER+"vista.jpg",title="new_concept",url="",fanart=STATIC_SERVER+"logo.jpg",show="11368"))
			itemlist.append( Item(channel=__channel__,action="download_all_next",thumbnail=STATIC_SERVER+"vista.jpg",title=" Descarga siguientes capitulos",url="",fanart=STATIC_SERVER+"logo.jpg",show="11368"))
			itemlist.append( Item(channel=__channel__,action="delete_all_watched",thumbnail=STATIC_SERVER+"vista.jpg",title=" Borra los vistos ",url="",fanart=STATIC_SERVER+"logo.jpg",show="11368"))
			itemlist.append( Item(channel=__channel__,action="update_stormseries",thumbnail=STATIC_SERVER+"vista.jpg",title="Update",url="",fanart=STATIC_SERVER+"logo.jpg"))
			itemlist.append( Item(channel=__channel__,action="newmainlist",thumbnail=STATIC_SERVER+"vista.jpg",title=" Actualizar series siguiendo",url="",fanart=STATIC_SERVER+"logo.jpg"))
		if (os.path.exists(path+"activeseries.xml")):
			xml="activeseries.xml"
			#itemlist.append( Item(channel=__channel__,action="other_series",thumbnail=STATIC_SERVER+"vista.jpg",title="Otras Series",url="",fanart=STATIC_SERVER+"logo.jpg"))
		else:
			urllib.urlretrieve (SERVER+"tvseries/following/user/"+user_id+"/pass/"+user_pass+"/view/"+view, path+"following.xml")
			xml="following.xml"
		serieslist=seriesxml_toitemlist(xml,"")
		if (os.path.exists(path+"activeseries.xml")):
			serieslist.append( Item(channel=__channel__,action="other_series",thumbnail=STATIC_SERVER+"vista.jpg",title="Otras Series",url="",fanart=STATIC_SERVER+"logo.jpg"))
		itemlist=itemlist+serieslist
	else:
		itemlist=[]
		itemlist.append( Item(channel=__channel__, action="channel" , title="Usuario o contrasea incorrectas", fulltitle="" , url="", thumbnail="", plot="", viewmode="movie", show="" ,fanart=""))
	return itemlist
####
#
#	FUncion que devuelve un itemlist dado un xml de tipo series
#
####
def seriesxml_toitemlist(xmlfile,searchpath):
	path=config.get_data_path()+"stormtv/temp/"
	xml=path+xmlfile
	itemlist=[]
	if (DEBUG): logger.info( "[stormtv.py] seriesxml_toitemlist path:"+xml)
	tvserie = ET.parse(xml)
	series=tvserie.getroot()
	for serie in series.findall('serie'):
		name = serie.find('name').text
		name = name.encode("utf-8")
		name = replace_acent(name)
		id = serie.find('id').text
		fanart = serie.find('fanart').text
		poster = serie.find('poster').text
		type = serie.find('type').text
		channels = serie.find('channels')
		try:
			plot = serie.find('plot').text
			plot=plot.encode("utf-8")
		except:
			plot=""
		art=STATIC_SERVER+fanart
		tvshow=path+searchpath+id+".xml"
		if not os.path.exists(tvshow):
			tvserie = ET.ElementTree(serie)
			tvserie.write(tvshow)
		if (type=="1"):
			itemlist.append( Item(channel=__channel__, action="movie_options" , title=name, fulltitle=name , url=id, thumbnail=STATIC_SERVER+poster, plot=plot, viewmode="movie", show=id ,fanart=art))
		elif (type=="0"):
			itemlist.append( Item(channel=__channel__, action="tvserie_options" , title=name, fulltitle=name , url=id, thumbnail=STATIC_SERVER+poster, plot=plot, viewmode="movie", show=id ,fanart=art))
		else:
			itemlist.append( Item(channel=__channel__, action="listtvs" , title=name, fulltitle=name , url=id, thumbnail=STATIC_SERVER+poster, plot=plot, viewmode="movie", show=id,fanart=art))
	return itemlist
####
#
#	Funcion que muestra las series o peliculas que no se estan siguiendo habitualmente
#
####	
def other_series(item):
	if (DEBUG): logger.info("[stormtv.py] other_series")
	import xbmc,sys
	if (PREFERENCES=="0"):
		user_id = config.get_setting("stormtvuser")
		user_pass = config.get_setting("stormtvpassword")
		itemlist = []
		otherlist=[]
		xml="otherfollowing.xml"
		otherlist=seriesxml_toitemlist(xml,"")
		itemlist=itemlist+otherlist
	else:
		itemlist=[]
		itemlist.append( Item(channel=__channel__, action="channel" , title="Usuario o contrase񡠩ncorrectas", fulltitle="" , url="", thumbnail="", plot="", viewmode="movie", show="" ,fanart=""))
	return itemlist

def movie_options(item):
	import xbmcgui
	#createxml(item.show)
	filters=[]
	dialog=xbmcgui.Dialog()
	orden=["Enlaces","Trailer"]
	order=["Links","Trailer"]
	if (stormlib.isfollow(item.show)=='0'):
		orden.append("<Añadir a Favoritas>")
		order.append("addfollow")
	else:
		orden.append("<Quitar de Favoritas>")
		order.append("removefollow")
	select=dialog.select("Selecciona opcion",orden)
	view=order[select]
	if (select==-1):
		return
	elif (view=="Trailer"):
		return trailer(Item(channel=__channel__, action="trailer" , title=item.title, fulltitle=item.fulltitle , url=item.url, thumbnail=item.thumbnail, plot=item.plot, viewmode="movie", show=item.show ,fanart=item.fanart, extra=item.title))
	elif (view=="Links"):
		return conceptmovie(Item(channel=__channel__, action="conceptmovie" , title=item.title, fulltitle=item.fulltitle , url=item.url, thumbnail=item.thumbnail, plot=item.plot, viewmode="movie", show=item.show ,fanart=item.fanart))
	elif (view=="removefollow"):
		removefollow(item.show)
	elif (view=="addfollow"):
		addfollow(item.show)
		
def tvserie_options(item):
	adv = config.get_setting("stormtvadv")
	path=config.get_data_path()+"stormtv/temp/"
	preferences_xml=path+item.show+"_preferences.xml"
	import xbmcgui
	filters=[]
	episodelist=[]
	orden=[]
	order=[]
	episodelist=next_chapters(item.show)
	tvslang=stormlib.getverifylang()
	tvslang=stormlib.gettvslang(item.show)
	for episode in episodelist:
		if (DEBUG): logger.info( episode.title)
		orden.append(episode.title)
		order.append(episode.title)
	orden.append("Temporadas")
	order.append("Links")
	orden.append("Trailer")
	order.append("Trailer")
	orden.append("Preferencias")
	order.append("Preferences")
	if (adv == "true"):
		orden.append("Channels")
		order.append("Channels")
		orden.append("Cache")
		order.append("Cache")
		orden.append("Delete")
		order.append("Delete")
	dialog=xbmcgui.Dialog()
	if (stormlib.isfollow(item.show)=='0'):
		orden.append("<Añadir a Favoritas>")
		order.append("addfollow")
	else:
		orden.append("<Quitar de Favoritas>")
		order.append("removefollow")
	select=dialog.select("Selecciona opcion",orden)
	view=order[select]
	if (select==-1):
		return
	elif (view=="Trailer"):
		return trailer(Item(channel=__channel__, action="trailer" , title=item.title, fulltitle=item.fulltitle , url=item.url, thumbnail=item.thumbnail, plot=item.plot, viewmode="movie", show=item.show ,fanart=item.fanart, extra=item.title))
	elif (view=="Links"):
		return conceptseason(Item(channel=__channel__, action="conceptseason" , title=item.title, fulltitle=item.fulltitle , url=item.url, thumbnail=item.thumbnail, plot=item.plot, viewmode="movie", show=item.show ,fanart=item.fanart, extra="0"))
	elif (view=="removefollow"):
		removefollow(item.show)
	elif (view=="addfollow"):
		addfollow(item.show)
	elif (view=="Cache"):
		cache_links(item.show,"")
	elif (view=="Delete"):
		delete_watched(item.show,"")
	elif (view=="Preferences"):
		return preference_options((Item(channel=__channel__, action="tvspreferences" , title=item.title, fulltitle=item.fulltitle , viewmode="movie", show=item.show , extra="VOS")))
	elif (view=="Channels"):
		return listchannels((Item(channel=__channel__, action="listchannels" , title=item.title, fulltitle=item.fulltitle , url=item.url, thumbnail=item.thumbnail, plot=item.plot, viewmode="movie", show=item.show ,fanart=item.fanart, extra="0")))
	else:
		return conceptfind(Item(channel=__channel__, action="conceptfind" , title=orden[select], fulltitle=orden[select].replace(" ¡¡"+tvslang+"!!",""), show=item.show,extra="0"))
	#if (DEBUG): logger.info( view)


def preference_options(item):
	import xbmcgui
	dialog=xbmcgui.Dialog()
	orden=[]
	order=[]
	
	orden.append("VOS")
	order.append("VOS")
	orden.append("SPA")
	order.append("SPA")
	orden.append("VO")
	order.append("VO")
	orden.append("OTROS")
	order.append("OTROS")
	select=dialog.select("Selecciona el idioma preferido para esta serie",orden)
	view=order[select]
	if (select==-1):
		return
	elif (view=="VOS"):
		return tvspreferences((Item(channel=__channel__, action="tvspreferences" , title=item.title, fulltitle=item.fulltitle , viewmode="movie", show=item.show , extra="VOS")))
	elif (view=="SPA"):
		return tvspreferences((Item(channel=__channel__, action="tvspreferences" , title=item.title, fulltitle=item.fulltitle , viewmode="movie", show=item.show , extra="SPA")))
	elif (view=="VO"):
		return tvspreferences((Item(channel=__channel__, action="tvspreferences" , title=item.title, fulltitle=item.fulltitle , viewmode="movie", show=item.show , extra="VO")))
	else:
		return tvspreferences((Item(channel=__channel__, action="tvspreferences" , title=item.title, fulltitle=item.fulltitle , viewmode="movie", show=item.show , extra="OTROS")))

def change_view(item):
    import xbmcgui
    dialog=xbmcgui.Dialog()
    orden=["Peliculas","Series","Todas"]
    order=["Movies","Tvseries","Mixed"]
    view=order[dialog.select("Selecciona la vista preferida",orden)]
    if (DEBUG): logger.info( view)
    return mainlist(Item(channel=__channel__, title="stormtv", action="mainlist", extra=view ))

def addfollow(show):
	logger.info("[stormtv.py] Addfollow "+show)
	from core import stormlib
	stormlib.addfollow(show)
	import xbmcgui
	advertencia = xbmcgui.Dialog()
	advertencia.ok("Stormtv","Se ha añadido el elemento de favoritos")
	return
def removefollow(show):
	logger.info("[stormtv.py] Removefollow "+show)
	from core import stormlib
	stormlib.removefollow(show)
	import xbmcgui
	advertencia = xbmcgui.Dialog()
	advertencia.ok("Stormtv","Se ha quitado el elemento de favoritos")
	#return

	
####
#
#	Crea un fichero id_preferences.xml para poder especificar un idioma especifico para una serie, en vez del general.
#
####
def	tvspreferences(item):
	path=config.get_data_path()+"stormtv/temp/"
	preferences_xml=path+item.show+"_preferences.xml"
	root = ET.Element('Data')                         
	id=ET.fromstring('<id>'+item.show+'</id>')
	id.set('lang',item.extra)
	root.append(id)
	tvserie = ET.ElementTree(root)
	tvserie.write(preferences_xml)


'''
Requerido: item.show (identificador del show), item.extra(se forzara la actualizacion?, si es 0 no, si es 1 se fuerza la actualizacion)
'''
def conceptseason(item):
	if (DEBUG): logger.info ("[stormtv.py] Conceptseason - Start"+str(datetime.datetime.today()))
	yesterday=datetime.date.today() - datetime.timedelta(1)
	#week=datetime.timedelta(weeks=1)
	today=datetime.date.today()
	path=config.get_data_path()+"stormtv/temp/"
	chapters_xml=path+item.show+"_chapters.xml"
	tvserie_xml=path+item.show+".xml"
	storm_title=item.title
	storm_show=item.show
	force_update=item.extra
	update_xml = path+storm_show+"_updates.xml"
	updated=0
	# Si ya existe el fichero chapters y no se fuerza la actualizacion
	if ((os.path.exists(chapters_xml))and(force_update=="0")):
		updated=0
	else:
		updated=1		# Si no tenemos fichero forzaremos a que se cree
	
	chap_dictionary=stormlib.getwatched(item.show)
	sea_dict={}
	lang_dict={}
	chan_dict={}
	itemlist=[]
	dict={}
	
	if (os.path.exists(path+storm_show+".xml")):
		tvserie_xml=path+storm_show+".xml"
	elif ((os.path.exists(path+"search/"+storm_show+".xml"))):
		tvserie_xml=path+"search/"+storm_show+".xml"
	else:
		tvserie_xml=path+"nocatalogsearch/"+storm_show+".xml"
	
	if (DEBUG): logger.info( "[stormtv.py] Conceptseason el xml a leer:"+tvserie_xml)
	if (updated==0):
		tvserie = ET.parse(tvserie_xml)
		root=tvserie.getroot()
		name=root.find('name')
		library_fulltitle=replace_acent(name.text)
		tvserie = ET.parse(chapters_xml)
		root=tvserie.getroot()
		#leer del fichero update
		for episode in root.findall('Episode'): #Lee todos los episodios para saber cuantas temporadas tiene, es un error... de tiempo
			sea=episode.find('Season').text
			if (sea not in sea_dict):
				sea_dict[sea]="yes"
				itemlist.append(Item(channel=__channel__, action="conceptchapter" , title="Temporada "+sea, fulltitle=item.fulltitle , url="", thumbnail=item.thumbnail, fanart=item.fanart, plot=item.plot, show=storm_show, extra=sea))
		itemlist.append( Item(channel=__channel__, action="update_serie" , title="Actualizar Temporadas", thumbnail=item.thumbnail, plot=item.plot, show=storm_show ,fanart=item.fanart, extra="1"))
	else:
		if (DEBUG): logger.info( "[stormtv.py] Conceptseason generacion de fichero _chapters nuevo.")
		if (os.path.exists(chapters_xml)):
			os.remove(chapters_xml)
		#if (force_update=="1"):
		#volver a crear el fichero de la serie.
		
		doc = ET.parse(tvserie_xml)
		root = doc.getroot()
		name=root.find('name')
		library_fulltitle=replace_acent(name.text)
		channels=root.find('channels')
		for channel in channels.findall('channel'):
			name=channel.find("name").text
			oname=channel.find("original_name").text
			url=channel.find("url").text
			try:
				lang=channel.find("lang").text
				lang_dict[url]=lang
				chan_dict[name]=lang
			except:
				pass
			if (DEBUG): logger.info ("name:"+name.encode('ascii','ignore')+"original_name:"+oname.encode('ascii','ignore')+"url:"+url)
			#try:
			conceptchanneltvs(Item(channel=__channel__,title=oname+" <"+name+ ">",fulltitle=name,url=url,show=storm_show),dict)
			#except:
			#	pass
		episodes=dict.keys() 	#obtenemos los capitulos que hemos añadido al diccionario
		episodes.sort()			#ordenamos los capitulos
		

		tvserie = ET.ElementTree(stormlib.create_serie(item.show))
		root=tvserie.getroot()
		for episode in episodes:
			sea,chap=stormlib.seachap(episode)
			title, extra, watched = stormlib.iswatched(episode,chap_dictionary)
			extra=""
			newepisode=ET.Element('Episode')
			newepisode.set('number',episode)
			newepisode.set('season',sea)
			if (episode in chap_dictionary):
				newepisode.set('watched',"True")
			number=ET.fromstring('<Number>'+chap+'</Number>')
			season=ET.fromstring('<Season>'+sea+'</Season>')
			newepisode.append(number)
			newepisode.append(season)
			links=dict[episode]
			if (DEBUG): logger.info ("[stormtv.py] Conceptseason - Enlaces:"+links)
			links=links.split("*")
			for link in links:
				if (DEBUG): logger.info( "[stormtv.py] conceptseason link:"+link)
				cut=link.split(";")
				schannel=cut[0]
				surl=cut[1]
				surl=surl.replace("&","&amp;")
				surl=force_decode(surl)
				#aunque parezca mentira hay urls con accentos !!
				surl=replace_acent(surl)
				if ((surl in lang_dict) or (schannel in chan_dict)):
					if (surl in lang_dict):
						newepisode.append(ET.fromstring('<Channel name="'+schannel+'" lang="'+lang_dict[surl]+'">'+surl+'</Channel>'))
					else:
						newepisode.append(ET.fromstring('<Channel name="'+schannel+'" lang="'+chan_dict[schannel]+'">'+surl+'</Channel>'))
				else:
					newepisode.append(ET.fromstring('<Channel name="'+schannel+'" lang="multi">'+surl+'</Channel>'))
			root.append(newepisode)
			if (sea not in sea_dict):
				sea_dict[sea]="yes"
				itemlist.append(Item(channel=__channel__, action="conceptchapter" , title="Temporada "+sea, fulltitle=item.fulltitle , url=url, thumbnail=item.thumbnail, fanart=item.fanart, plot=item.plot, show=storm_show, extra=sea))
			tvserie.write(chapters_xml)
			if (DEBUG): logger.info ("[stormtv.py] Conceptseason - Time"+str(datetime.datetime.today()))
		# Dado que hemos generado un nuevo fichero _chapters.xml creamos tambien el fichero _updates.xml
		if not os.path.exists(path+storm_show+"_updates.xml"):
			create_updatexml(storm_show,sea_dict)
		else:
			if (DEBUG): logger.info( "[stormtv.py] El fichero _updates.xml ya existe")
	#tvserie = ET.parse(tvserie_xml)
	#root=tvserie.getroot()
	#name=root.find('name')
	#library_fulltitle=replace_acent(name.text)
	itemlist.append(Item(channel=__channel__, title="Añadir esta serie a la biblioteca de XBMC", url="",fulltitle=library_fulltitle, action="add_serie_to_library", extra="conceptlibrary###"+storm_title, show=storm_show,fanart=item.fanart) )
	
	if (DEBUG): logger.info ("[stormtv.py] Conceptseason - End"+str(datetime.datetime.today()))
	return itemlist


################################
##  ListChannels
##
################################
def listchannels(item):
	if (DEBUG): logger.info ("[stormtv.py] Listchannels - Start"+str(datetime.datetime.today()))
	path=config.get_data_path()+"stormtv/temp/"
	tvserie_xml=path+item.show+".xml"
	storm_title=item.title
	storm_show=item.show
	force_update=item.extra
	
	updated=0
	# Si ya existe el fichero chapters y no se fuerza la actualizacion
	
	chap_dictionary=stormlib.getwatched(item.show)
	itemlist=[]
	
	if (os.path.exists(path+storm_show+".xml")):
		tvserie_xml=path+storm_show+".xml"
	elif ((os.path.exists(path+"search/"+storm_show+".xml"))):
		tvserie_xml=path+"search/"+storm_show+".xml"
	else:
		tvserie_xml=path+"nocatalogsearch/"+storm_show+".xml"
	
	if (DEBUG): logger.info( "[stormtv.py] ListChannels el xml a leer:"+tvserie_xml)
	if (updated==0):
		tvserie = ET.parse(tvserie_xml)
		root=tvserie.getroot()
		name=root.find('name').text
		channels=root.find('channels')
		name = name.encode("utf-8")
		
		
		fanart = root.find('fanart').text
		poster = root.find('poster').text
		type = root.find('type').text
		if (DEBUG): logger.info( "name"+name)
		try:
			plot = serie.find('plot').text
			plot=plot.encode("utf-8")
		except:
			plot=""
		#leer del fichero update
		for channel in channels.findall('channel'): #Lee todos los episodios para saber cuantas temporadas tiene, es un error... de tiempo
			cname=channel.find('name').text
			coname=channel.find('original_name').text
			curl=channel.find('url').text
			id=storm_show+"_"+cname
			if (DEBUG): logger.info( "name->"+id+"<-name")
			tvshow=path+"nocatalogsearch/"+id+".xml"
			root = ET.Element('serie')                         
			root.append(ET.fromstring('<id>'+id+'</id>'))
			root.append(ET.fromstring('<name>'+name+'</name>'))
			root.append(ET.fromstring('<fanart>'+fanart+'</fanart>'))
			root.append(ET.fromstring('<poster>'+poster+'</poster>'))
			root.append(ET.fromstring('<plot>'+plot+'</plot>'))
			root.append(ET.fromstring('<type>'+type+'</type>'))
			xchannels = ET.Element('channels')
			xchannels.append(channel)
			root.append(xchannels)
			if not os.path.exists(tvshow):
				tvserie2 = ET.ElementTree(root)
				tvserie2.write(tvshow)
			#series=tvserie.getroot()
			#
			#
			itemlist.append( Item(channel=__channel__, action="conceptseason" , title=cname+" "+coname, thumbnail=item.thumbnail, plot=plot, show=id ,fanart=fanart, extra="0"))
	else:
		if (DEBUG): logger.info( "[stormtv.py] listchannels.")
	if (DEBUG): logger.info ("[stormtv.py] listchannels - End"+str(datetime.datetime.today()))
	return itemlist

################################
# Con esta funcion pretendemos encontrar aquellos enlaces que esten disponibles
# y que se muestren antes
##################################
def conceptverified2(itemlist,chapter,lang,show):
	path=config.get_data_path()+"stormtv/temp/"
	verified_xml=path+show+"_links_"+chapter+"_"+lang+"_verified.xml"
	verifiedET = ET.ElementTree(stormlib.create_chapter(show))
	verifiedETroot=verifiedET.getroot()
	logger.info("[stormtv.py] Findvideos - Filtro Idioma:"+LANG+" Filtro Servers:"+SERVERS)
	dictionary={}
	#esta lista hay que sacarla de la configuracion del servidor no debe ser estatica
	cexcluded=["elitetorrent"]
	strue=0
	ltrue=0
	verified=[]
	vserver=""
  	excluded=[]
	storm_itemlist=[]
	excluded=["letitbit","torrent","desconocido"]
	#direct=["enlacia","cinetux","shurweb","zpeliculas","cinehanwer","sintonizzate","shurweb","seriesadicto","vseries","newpct1","pepecine","divxatope","hdfull","animeid","allpeliculas"]
	direct=stormlib.getpagesdirect()
	logger.info("tamanyo direct:"+str(len(direct)))
	for c in direct:
		logger.info("channel_name:"+c)
	preprocess=["seriesdanko","seriesflv","seriesblanco","seriesyonkis","oranline"]
	for item in itemlist:
		storm_fanart=item.fanart
		storm_plot=item.plot
		storm_thumbnail=item.thumbnail
		storm_chapter=item.extra
		storm_show=item.show
		storm_channel_name=item.fulltitle
		storm_title=item.title
		free_url=item.url
		item.url=item.url.replace("&amp;","&")
		vserver=item.server
		#Si el canal es shurweb le  (spa)
		fserver=item.server
		strue=1
		logger.info("[stormtv.py] title"+item.title)
		title=item.title.lower()
		res=False
		if (storm_channel_name=="elitetorrent"):
			data = scrapertools.cache_page(item.url)
			try:
				link = scrapertools.get_match(data,'<a href="(magnet[^"]+)" class="enlace_torrent[^>]+>Descargar por magnet link</a>')
				link = urlparse.urljoin(item.url,link)
			except:
				link=""
			item.url=link
			item.title="[Verificado]"+item.title
			strue=1
			vserver="torrent"
			s_url=link
		if (strue==1):
			strue=0
			# si el canal no es uno que no podamos comprobar los enlaces xq esten "cifrados"
			if (storm_channel_name not in cexcluded):
				# si no hemos verificado ya un enlace de ese servidor o si el servidor no se puede verificar
				if ((vserver not in verified)&(vserver not in excluded)):
				#if (vserver not in excluded):
					try:
						exec "import servers."+vserver+" as tserver"
					except:
						if (DEBUG): logger.info( "[stormtv.py] Free Verify no existe el servidor")
					logger.info("storm_channel_name: "+storm_channel_name)
                    #   #Shurweb y otros canales que usan la funcion generica de findvideos tienen el enlace directamente, no hay que descargar la pagina.
					if (storm_channel_name in direct):
						if (DEBUG): logger.info( "conceptverified->direct")
						try:
							res,test= tserver.test_video_exists(item.url)
							s_url=item.url
						except:
							if (DEBUG): logger.info( "[stormtv.py] Free Verify no find_videos")
							res=False
					else:
					#	if (DEBUG): logger.info( "dentro del else<>shurweb")
						if (DEBUG): logger.info( "conceptverified->process:"+ item.url)
						try:
							data =scrapertools.cache_page(item.url)
							if (DEBUG): logger.info( data)
							find_url= tserver.find_videos(data)
							if (DEBUG): logger.info( "URL------------>"+find_url[0][1])
							s_url=find_url[0][1]
							res,test= tserver.test_video_exists(find_url[0][1])
						except:
					#		if (DEBUG): logger.info( "[stormtv.py] Verified fallo test_video_exist "+vserver)
							res=False
							if ("Please try again in a few minutes." in data):
								cexcluded.append(storm_channel_name)
					if (res):
						if (DEBUG): logger.info("[stormtv.py] Free Verify True#"+test)
						if (vserver.upper() in dictionary):
							item.title="[Verificado] "+dictionary[vserver.upper()]+item.title
							verified.append(vserver)
						else:
							item.title="[Verificado] "+item.title
							verified.append(vserver)
							strue=1
						#if (DEBUG): logger.info( "server="+SERVER+"vserver"+vserver
						additem=0
						if ((SERVERS=="2") and (vserver in ALL_SERVERS)):
							verifiedETroot.append(create_link(lang,storm_channel_name,s_url,item.show,vserver))
							storm_itemlist.append( Item(channel=__channel__, action="play" , title=item.title, fulltitle=storm_channel_name , url=s_url, thumbnail=storm_thumbnail,  plot=storm_plot, folder=False, fanart=storm_fanart, server=vserver, extra=storm_chapter,show=item.show))
							additem==1
						elif ((SERVERS=="1") and (vserver in servertools.FREE_SERVERS)):
							verifiedETroot.append(create_link(lang,storm_channel_name,s_url,item.show,vserver))
							storm_itemlist.append( Item(channel=__channel__, action="play" , title=item.title, fulltitle=storm_channel_name , url=s_url, thumbnail=storm_thumbnail,  plot=storm_plot, folder=False, fanart=storm_fanart, server=vserver, extra=storm_chapter,show=item.show))
							additem==1
						elif (SERVERS=="0"):
							logger.info( "---create_link--------->"+s_url)
							verifiedETroot.append(create_link(lang,storm_channel_name,s_url,item.show,vserver))
							storm_itemlist.append( Item(channel=__channel__, action="play" , title=item.title, fulltitle=storm_channel_name , url=s_url, thumbnail=storm_thumbnail,  plot=storm_plot, folder=False, fanart=storm_fanart, server=vserver, extra=storm_chapter,show=item.show))
							additem==1
						#if (additem==1):
						#	verifiedETroot.append(create_link(lang,storm_channel_name,s_url,item.show,vserver))
						#	storm_itemlist.append( Item(channel=__channel__, action="play" , title=item.title, fulltitle=storm_channel_name , url=s_url, thumbnail=storm_thumbnail,  plot=storm_plot, folder=False, fanart=storm_fanart, server=vserver, extra=storm_chapter,show=item.show))
					else:
						if (DEBUG): logger.info("[stormtv.py] findvideos false")
						item.title=vserver
						strue=0
				else:
					if (DEBUG): logger.info( "[stormtv.py] conceptverified2 vserver in excluded")
					if (vserver=="torrent"):
						if (storm_channel_name=="newpct1"):
							s_url=item.url
							item.title="[Verificado]"+item.title
						if (DEBUG): logger.info( "[stormtv.py] conceptverified2 vserver=torrent "+item.url)
						verifiedETroot.append(create_link(lang,storm_channel_name,s_url,item.show,vserver))
					#aunque se haya verificado ya enlaces de ese servidor se añaden a la lista
					storm_itemlist.append( Item(channel=__channel__, action="play" , title=item.title, fulltitle=storm_channel_name , url=item.url, thumbnail=storm_thumbnail,  plot=storm_plot, folder=False, fanart=storm_fanart, server=vserver, extra=storm_chapter,show=item.show))
			else:
				if (DEBUG): logger.info( "[stormtv.py] conceptverified2 vserver in excluded")
				if (vserver=="torrent"):
					if (storm_channel_name=="newpct1"):
						s_url=item.url
					if (DEBUG): logger.info( "[stormtv.py] conceptverified2 vserver=torrent "+item.url)
					verifiedETroot.append(create_link(lang,storm_channel_name,s_url,item.show,vserver))
				#Aunque no podamos verificar los enlaces los añadimos a la lista
				if (DEBUG): logger.info("[stormtv.py] conceptverified2 item.title="+item.title+",url:"+item.url)
				storm_itemlist.append( Item(channel=__channel__, action="play" , title=item.title+"<"+storm_channel_name+">", fulltitle=storm_channel_name , url=item.url, thumbnail=storm_thumbnail,  plot=storm_plot, folder=False, fanart=storm_fanart, server=vserver, extra=storm_chapter,show=item.show))

	#return storm_itemlist
	verifiedET.write(verified_xml)
	return sorted(storm_itemlist, key=lambda Item: Item.title,reverse=True)

def create_link(link_lang,link_channel,link_url,link_show,link_server):
	if (DEBUG): logger.info("[stormtv.py] create_link"+link_url)
	
	newepisode=ET.Element('Link')
	newepisode.set('lang',link_lang)
	language=ET.fromstring('<Lang>'+link_lang+'</Lang>')
	link_url=link_url.replace("&","&amp;")
	url=ET.fromstring('<Url>'+link_url+'</Url>')
	channel=ET.fromstring('<Channel>'+link_channel+'</Channel>')
	show=ET.fromstring('<Show>'+link_show+'</Show>')
	server=ET.fromstring('<Server>'+stormlib.getserver(link_server)+'</Server>')
			
	newepisode.append(url)
	newepisode.append(channel)
	newepisode.append(show)
	newepisode.append(language)
	newepisode.append(server)

	return newepisode



def conceptlibrary(item):
	#<name>All&iacute; Abajo</name>
	if (DEBUG): logger.info("[stormtv.py] conceplibrary"+" "+item.title)
	if (DEBUG): logger.info("[stormtv.py] conceplibrary"+" "+item.fulltitle)
	path=config.get_data_path()+"stormtv/temp/"
	xml=path+item.show+".xml"
	tvserie = ET.parse(xml)
	root=tvserie.getroot()
	name=root.find('name')
	storm_fulltitle=name.text
	if (DEBUG): logger.info("[stormtv.py] conceplibrary Name:"+" "+storm_fulltitle)
	xml=path+item.show+"_chapters.xml"
	id=item.show
	itemlist=[]
	tvserie = ET.parse(xml)
	root=tvserie.getroot()
	title=""
	for episode in root.findall("Episode"):
			title=episode.get('number')
			itemlist.append(Item(channel=__channel__, action="conceptfind" , title=title, fulltitle=storm_fulltitle , url="", thumbnail="", fanart="", plot="",show=id,extra="0"))
	return itemlist
#Mostrará los capítulos según la temporada elegida
# Requerido: item.extra= temporada seleccionada, item.show=identificador de la serie
def conceptchapter(item):
	if (DEBUG): logger.info("[stormtv.py] conceptchapter [item.extra/Temporada]"+item.extra)
	if (DEBUG): logger.info("[stormtv.py] conceptchapter item.show"+item.show)
	path=config.get_data_path()+"stormtv/temp/"
	xml=path+item.show+"_chapters.xml"
	id=item.show
	#chap_dictionary=stormlib.getwatched(item.show)
	itemlist=[]
	tvserie = ET.parse(xml)
	root=tvserie.getroot()
	title=""
	for episode in root.findall("Episode[@season='"+item.extra+"']"):
			if (episode.get('watched') =="True"):
				title=episode.get('number')+" [COLOR green][Visto][/COLOR]"
			else:
				title=episode.get('number')
			itemlist.append(Item(channel=__channel__, action="conceptfind" , title=title, fulltitle=episode.get('number') , url=item.url, thumbnail=item.thumbnail, fanart=item.fanart, plot=item.plot,show=id,extra="0"))
	return itemlist
	
def conceptmovie(item):
	storm_title=item.title
	storm_fanart=item.fanart
	storm_thumbnail=item.thumbnail
	storm_show=item.show
	allurl=""
	itemlist=conceptfind(Item(channel=__channel__,fulltitle=storm_title,url=allurl,show=storm_show,fanart=storm_fanart,thumbnail=storm_thumbnail,extra='1'))
	return itemlist
	

def conceptfind(item):
  if (DEBUG): logger.info( "[conceptfind] find "+item.title)
  if (DEBUG): logger.info( "[conceptfind] show:"+item.show)
  if (DEBUG): logger.info( "[conceptfind] fanart:"+item.fanart)
  if (DEBUG): logger.info( "[conceptfind] url:"+item.url+ " "+item.extra)
  if (DEBUG): logger.info( "[conceptfind] storm_chapter:"+item.fulltitle)
  if (DEBUG): logger.info( "[conceptfind] storm_type:"+item.extra)
  tvslang=stormlib.getverifylang()
  #tvslang="SPA"
  storm_fanart=item.fanart
  storm_plot=item.plot
  storm_thumbnail=item.thumbnail
  storm_type=item.extra
  storm_show=item.show
  storm_title=item.title
  storm_chapter=item.fulltitle
	
  path=config.get_data_path()+"stormtv/temp/"
  tvslang=stormlib.gettvslang(item.show)
  verified_xml=path+storm_show+"_links_"+storm_chapter+"_"+tvslang+"_verified.xml"
  if not os.path.exists(verified_xml):
	ch=[]
	storm_file=storm_show
	#storm_type="0" indicamos que es una serie y tendremos que buscar en los enlaces de los capitulos
	# si es 1 debemos buscar en los enlaces de la tvserie directamente.
	if (storm_type=="0"):
		storm_file=storm_file+"_chapters"
	if (os.path.exists(path+storm_file+".xml")):
		xml=path+storm_file+".xml"
	elif (os.path.exists(path+"search/"+storm_file+".xml")):
		xml=path+"search/"+storm_file+".xml"
	else:
		xml=path+"nocatalogsearch/"+storm_file+".xml"
	if (DEBUG): logger.info( "ruta del fichero"+xml)
	if (storm_type=="0"):
		if os.path.exists(xml):
			tvserie = ET.parse(xml)
			root=tvserie.getroot()
			channels=root.find("Episode[@number='"+storm_chapter+"']")
			ch = channels.findall('Channel')
	else:
		if os.path.exists(xml):
			tvserie=ET.parse(xml)
			node=tvserie.getroot()
			channels=node.find('channels')
			ch = channels.findall('channel')
	itemlist=[]
	itemlist2=[]
	# hay que obtener este array desde las preferencias, en elitetorrent solo hay un enlace no hay que buscarlo
	excluded=["elitetorrent"]
	bitemlist=[]
	action="findvideos"
	movieactiondict={}
	tvserieactiondict={}
	movieactiondict=stormlib.getmovieaction()
	tvserieactiondict=stormlib.gettvserieaction()
	for c in ch:
		slang=""
		if (storm_type=='0'):
			schannel=c.get('name')
			slang=c.get('lang')
			surl=c.text
		else:
			schannel = c.find('name').text
			surl = c.find('url').text	
		
		#if (schannel=="enlacia"):
		#	action="temporadas"
		#elif ((schannel=="pepecine") and (storm_type=="1")):
		#	action="get_movie"
		#elif ((schannel=="pepecine") and (storm_type=="0")):
		#	action="get_temporadas"
		#else:
		#	action="findvideos"
		if (storm_type=="0"):
			action=tvserieactiondict[schannel]
		else:
			action=movieactiondict[schannel]
		if (schannel not in excluded):
			itemn=Item(channel=__channel__,url=surl)
			exec "import channels."+schannel+" as channel"
                # El action nos devolvera el listado de posibles enlaces
			try:
				if (DEBUG): logger.info( "[stormtv_a.py] conceptfind -> Ejecutandon action findvideo del channel:"+schannel+" Url:"+surl)
				exec "itemlist = channel."+action+"(itemn)"
			except:
				if (DEBUG): logger.info( "Fallo en la ejecución del action Conceptfind probamos con el por defecto")
				itemlist= servertools.find_video_items(itemn)
				for items in itemlist:
					if (DEBUG): logger.info( "default_Find_video_items Title:"+items.title +"url:"+items.url+",server:"+ items.server)
			itemlist2=transform(schannel,storm_show,storm_fanart,storm_thumbnail,storm_chapter,slang,itemlist)
			bitemlist=bitemlist+itemlist2
		else:
			if ((schannel=="elitetorrent")and(item.extra=="0")):
				bitemlist.append( Item(channel=__channel__,action="play", server=item.server,fulltitle=schannel, title="[Verificado] Ver torrent "+c.get('lang'), url=surl , show=storm_show))
			elif ((schannel=="elitetorrent")and(item.extra=="1")):
				bitemlist.append( Item(channel=__channel__,action="play", server=item.server,fulltitle=schannel, title="[Verificado] Ver torrent "+c.find('lang').text, url=surl , show=storm_show))
	for item in bitemlist:
		if (DEBUG): logger.info( "channel:"+item.channel+","+item.title+"item.url:"+item.url+" ,"+storm_thumbnail+","+storm_fanart+"chapter:"+storm_chapter)
	parameters=Item(channel=__channel__, fanart=storm_fanart,thumbnail=storm_thumbnail,plot=storm_plot,show=storm_show,extra=storm_chapter)
	return languages(bitemlist,parameters)
  else:
	return directplay(Item(channel=__channel__, show=storm_show,extra=storm_chapter))
#con la funcion languages obtendremos los idiomas de los enlaces 
def forcefind(item):
	if (DEBUG): logger.info( "[conceptfind] find "+item.title)
	if (DEBUG): logger.info( "[conceptfind] show:"+item.show)
	if (DEBUG): logger.info( "[conceptfind] fanart:"+item.fanart)
	if (DEBUG): logger.info( "[conceptfind] url:"+item.url+ " "+item.extra)
	if (DEBUG): logger.info( "[conceptfind] storm_chapter:"+item.fulltitle)
	if (DEBUG): logger.info( "[conceptfind] storm_type:"+item.extra)
	storm_fanart=item.fanart
	storm_plot=item.plot
	storm_thumbnail=item.thumbnail
	storm_type=item.extra
	storm_show=item.show
	#storm_channel_name=item.fulltitle
	storm_title=item.title
	storm_chapter=item.fulltitle
	
	path=config.get_data_path()+"stormtv/temp/"
  
	ch=[]
	storm_file=storm_show
	#storm_type="0" indicamos que es una serie y tendremos que buscar en los enlaces de los capitulos
	# si es 1 debemos buscar en los enlaces de la tvserie directamente.
	if (storm_type=="0"):
		storm_file=storm_file+"_chapters"
	if (os.path.exists(path+storm_file+".xml")):
		xml=path+storm_file+".xml"
	elif (os.path.exists(path+"search/"+storm_file+".xml")):
		xml=path+"search/"+storm_file+".xml"
	else:
		xml=path+"nocatalogsearch/"+storm_file+".xml"
	if (DEBUG): logger.info( "ruta del fichero"+xml)
	if (storm_type=="0"):
		if os.path.exists(xml):
			tvserie = ET.parse(xml)
			root=tvserie.getroot()
			channels=root.find("Episode[@number='"+storm_chapter+"']")
			ch = channels.findall('Channel')
	else:
		if os.path.exists(xml):
			tvserie=ET.parse(xml)
			node=tvserie.getroot()
			channels=node.find('channels')
			ch = channels.findall('channel')
	itemlist=[]
	itemlist2=[]
	# hay que obtener este array desde las preferencias, en elitetorrent solo hay un enlace no hay que buscarlo
	excluded=["elitetorrent"]
	bitemlist=[]
	action="findvideos"
	for c in ch:
		slang=""
		if (storm_type=='0'):
			schannel=c.get('name')
			slang=c.get('lang')
			surl=c.text
		else:
			schannel = c.find('name').text
			surl = c.find('url').text	
		if (storm_type=="0"):
			try:
				action=tvserieactiondict[schannel]
			except:
				action="findvideos"
		else:
			try:
				action=movieactiondict[schannel]
			except:
				action="findvideos"
		#if (schannel=="enlacia"):
		#	action="temporadas"
		#elif ((schannel=="pepecine") and (storm_type=="1")):
		#	action="get_movie"
		#elif ((schannel=="pepecine") and (storm_type=="0")):
		#	action="get_temporadas"
		#else:
		#	action="findvideos"
		if (schannel not in excluded):
			itemn=Item(channel=__channel__,url=surl)
			exec "import channels."+schannel+" as channel"
                # El action nos devolvera el listado de posibles enlaces
			try:
				if (DEBUG): logger.info( "[stormtv_a.py] conceptfind -> Ejecutandon action findvideo del channel:"+schannel+" Url:"+surl)
				exec "itemlist = channel."+action+"(itemn)"
			except:
				if (DEBUG): logger.info( "Fallo en la ejecución del action Conceptfind probamos con el por defecto")
				itemlist= servertools.find_video_items(itemn)
				for items in itemlist:
					if (DEBUG): logger.info( "default_Find_video_items Title:"+items.title +"url:"+items.url+",server:"+ items.server)
			itemlist2=transform(schannel,storm_show,storm_fanart,storm_thumbnail,storm_chapter,slang,itemlist)
			bitemlist=bitemlist+itemlist2
		else:
			if ((schannel=="elitetorrent")and(item.extra=="0")):
				bitemlist.append( Item(channel=__channel__,action="play", server=item.server,fulltitle=schannel, title="[Verificado] Ver torrent "+c.get('lang'), url=surl , show=storm_show))
			elif ((schannel=="elitetorrent")and(item.extra=="1")):
				bitemlist.append( Item(channel=__channel__,action="play", server=item.server,fulltitle=schannel, title="[Verificado] Ver torrent "+c.find('lang').text, url=surl , show=storm_show))
	for item in bitemlist:
		if (DEBUG): logger.info( "channel:"+item.channel+","+item.title+"item.url:"+item.url+" ,"+storm_thumbnail+","+storm_fanart+"chapter:"+storm_chapter)
	parameters=Item(channel=__channel__, fanart=storm_fanart,thumbnail=storm_thumbnail,plot=storm_plot,show=storm_show,extra=storm_chapter)
	return languages(bitemlist,parameters)
  

def languages(p_itemlist,p_item):
	if (DEBUG): logger.info("[stormtv.py] languages")
	s_storm_show=p_item.show
	s_storm_chapter=p_item.extra
	s_storm_fanart=p_item.fanart
	s_storm_plot=p_item.plot
	s_storm_thumbnail=p_item.thumbnail
	
	yesterday=datetime.date.today() - datetime.timedelta(1)
	week=datetime.timedelta(weeks=1)
	today=datetime.date.today()
	path=config.get_data_path()+"stormtv/temp/"
	xml=path+s_storm_show+"_links_"+s_storm_chapter+".xml"
	if (DEBUG): logger.info ("[stormtv.py] languages - Time"+str(datetime.datetime.today()))
	updated=0
	if (os.path.exists(xml)):
		t = os.path.getmtime(xml)
		filedate = datetime.date.fromtimestamp(t)
		if (filedate<yesterday):
			updated=1 	# Si tiene mas de un dia queremos que se actualice
		else:
			updated=0 	# tenemos un fichero con los enlaces con menos de 1 dia, no queremos que lo vuelva  a actualizar
	else:
		updated=1		# Si no tenemos fichero forzaremos a que se cree
	dict={}
	langlist=[]
	if (updated==0):
		tvserie = ET.parse(xml)
		root=tvserie.getroot()
		for link in root.findall('Link'):
			lang=link.find('Lang').text
			if (lang not in dict):
				dict[lang]="yes"
				langlist.append(Item(channel=__channel__, action="listlang" , title=lang, plot=s_storm_plot , fanart=s_storm_fanart , thumbnail = s_storm_thumbnail, show=s_storm_show, extra=s_storm_chapter))
	else:
		if (os.path.exists(xml)):
			os.remove(xml)
		
		patron_vos='VOS|Sub'
		patron_vo='VO(?!S)|ING'
		patron_spa='Espa|spa|ESP|Cast'
		tvserie = ET.ElementTree(stormlib.create_chapter(s_storm_show))
		root=tvserie.getroot()
		for item in p_itemlist:
		
			storm_fanart=item.fanart
			storm_plot=item.plot                                                                                                                                                            
			storm_thumbnail=item.thumbnail                                                                                                                                                  
			storm_chapter=item.extra                                                                                                                                                         
			storm_show=item.show                                                                                                                                                            
			storm_channel_name=item.fulltitle                                                                                                                                                   
			storm_title=item.title
			storm_url=item.url.replace(";","")
			
			matches_vos = re.compile(patron_vos,re.DOTALL|re.IGNORECASE).findall(storm_title)	
			matches_vo = re.compile(patron_vo,re.DOTALL|re.IGNORECASE).findall(storm_title)
			matches_spa = re.compile(patron_spa,re.DOTALL|re.IGNORECASE).findall(storm_title)
			if (len(matches_vos)>0):		
				lang="VOS"
			elif (len(matches_vo)>0):
				lang="VO"
			elif (len(matches_spa)>0):
				lang="SPA"
			else:
				lang="OTROS"
			#if (DEBUG): logger.info( "Lang:"+lang
			if (stormlib.getserver(storm_title.lower())<>"Desconocido"):
				newepisode=ET.Element('Link')
				newepisode.set('lang',lang)
				language=ET.fromstring('<Lang>'+lang+'</Lang>')
				surl=storm_url.replace("&","&amp;")
				if (DEBUG): logger.info( "title:"+storm_title+"channel:"+storm_channel_name+"url:"+surl+",language:"+lang)
				url=ET.fromstring('<Url>'+surl+'</Url>')
				channel=ET.fromstring('<Channel>'+storm_channel_name+'</Channel>')
				show=ET.fromstring('<Show>'+storm_show+'</Show>')
				server=ET.fromstring('<Server>'+stormlib.getserver(storm_title.lower())+'</Server>')
			
				newepisode.append(url)
				newepisode.append(channel)
				newepisode.append(show)
				newepisode.append(language)
				newepisode.append(server)
				root.append(newepisode)
				if (lang not in dict):
					if (DEBUG): logger.info( "languages:"+LANG+" lang:"+lang)
					if ((LANG in ["2","4","6","0"]) and (lang =="VOS")):
						dict[lang]="yes"
						langlist.append(Item(channel=__channel__, action="listlang" , title=lang, show=s_storm_show, extra=s_storm_chapter,fanart=s_storm_fanart,thumbnail=s_storm_thumbnail,plot=s_storm_plot))
					elif ((LANG in ["3","5","6","0"])and (lang =="VO")):
						dict[lang]="yes"
						langlist.append(Item(channel=__channel__, action="listlang" , title=lang, show=s_storm_show, extra=s_storm_chapter,fanart=s_storm_fanart,thumbnail=s_storm_thumbnail,plot=s_storm_plot))
					elif ((LANG in ["1","4","5","0"]) and (lang =="SPA")):
						dict[lang]="yes"
						langlist.append(Item(channel=__channel__, action="listlang" , title=lang, show=s_storm_show, extra=s_storm_chapter,fanart=s_storm_fanart,thumbnail=s_storm_thumbnail,plot=s_storm_plot))
					elif (lang=="OTROS"):
						dict[lang]="yes"
						langlist.append(Item(channel=__channel__, action="listlang" , title=lang, show=s_storm_show, extra=s_storm_chapter,fanart=s_storm_fanart,thumbnail=s_storm_thumbnail,plot=s_storm_plot))
			else:
				if (DEBUG): logger.info( "[languajes] Servidor desconocido")
		tvserie.write(xml)
		if (DEBUG): logger.info ("[stormtv.py] language - Time"+str(datetime.datetime.today()))
	return langlist

# mostrará los enlaces segun el idioma seleccionado
# requerido: item.show= identificador de la serie o pelicula,item.extra=identificador del capitulo
def listlang(item):
	show=item.show
	chapter=item.extra
	path=config.get_data_path()+"stormtv/temp/"
	xml=path+show+"_links_"+chapter+".xml"
	lang=item.title
	tvserie = ET.parse(xml)
	root=tvserie.getroot()
	itemlist=[]
	verifiedlist=[]
	for link in root.findall('Link'):
		xlang=link.find('Lang').text
		if (xlang == lang):
			channel=link.find("Channel").text
			server=link.find("Server").text
			url=link.find("Url").text
			surl=url.replace("&","&amp;")
			itemlist.append(Item(channel=__channel__, action="play" , fulltitle=channel,title='<'+lang+'>'+server+" "+channel,url=surl,show=show,extra=chapter,server=server,folder=False,fanart=item.fanart,thumbnail=item.thumbnail,plot=item.plot))
	verifiedlist=conceptverified2(itemlist,chapter,lang,show)
	#verifiedlist+=next_chapters(show)
	return verifiedlist

def cache_verify(item):
	if (DEBUG): logger.info( "[stormtv.py] cache_verify")
	show=item.show
	chapter=item.extra
	path=config.get_data_path()+"stormtv/temp/"
	xml=path+show+"_links_"+chapter+".xml"
	lang=item.title
	tvserie = ET.parse(xml)
	root=tvserie.getroot()
	itemlist=[]
	for link in root.findall('Link'):
		xlang=link.find('Lang').text
		if (xlang == lang):
			channel=link.find("Channel").text
			server=link.find("Server").text
			url=link.find("Url").text
			surl=url.replace("&","&amp;")
			itemlist.append(Item(channel=__channel__, action="play" , fulltitle=channel,title='<'+lang+'>'+server+" "+channel,url=surl,show=show,extra=chapter,server=server,folder=False))
	if (len(itemlist)>0):
		conceptverified2(itemlist,chapter,lang,show)

def trailer(item):
    from core import trailertools
    resultlist=trailertools.youtube_search(item.extra+" trailer")
    itemlist=[]
    for result in resultlist:
	name=result[0]
	url=result[2]
	thumbnail=result[1]
	itemlist.append(Item(channel=__channel__, action="playtrailer" , title=name, fulltitle=name , url=url, thumbnail=thumbnail, plot=item.plot, viewmode="movie",folder=False,server="youtube",fanart=item.fanart))
    return itemlist
def playtrailer(item):
   from platformcode import xbmctools
   xbmctools.play_video("Trailer",item.server,item.url,"category",item.title,item.thumbnail,item.plot)

####
####  Core de todo el tinglado convierte los enlaces de todos los capitulos.
####
def conceptchanneltvs(item,dict):
		logger.info("[stormtv.py] Concept channeltvs ".encode("utf-8"))#+item.fulltitle +" ".encode("utf-8")+item.title)
		if (DEBUG): logger.info( "[stormtv.py] Concept channeltvs ")
		storm_fanart=item.fanart
		storm_show=item.show
		storm_channel_name=item.fulltitle
		storm_title=item.title
		action="episodios"
		path=config.get_data_path()+"stormtv/temp/"
		xml=path+item.show+".xml"
		itemlist=[]
		if (storm_channel_name=="elitetorrent"):
			if (DEBUG): logger.info( "######elitetorrent################")
			itemlist.append( Item(channel=__channel__,action="play", server=item.server,fulltitle=storm_channel_name, title=item.title, url=item.url , show=storm_show))
		elif (storm_channel_name=="pepecine"):
			nitem=Item(channel=__channel__,url=item.url,extra="serie_add")
			action="get_temporadas"
			exec "import channels."+storm_channel_name+" as channel"
			# El action nos devolvera el listado de capitulos (episodelist o episodios)
			try:
				exec "itemlist_p = channel."+action+"(nitem)"
				itemlist = itemlist_p
			except:
				pass
				
		elif (storm_channel_name=="divxatope"):
			if (DEBUG): logger.info( "Serie Divxatope" )
			patron="(.*) Temp ([0-9]*) [C-c]ap ([0-9]*)"
			matches=re.compile(patron,re.DOTALL).findall(storm_title)
			for title,season,episode in matches:
				if (len(episode)==1):
					storm_title=title+" "+season+"x0"+episode #chapucilla
				else:
					storm_title=title+" "+season+"x"+episode
				if (DEBUG): logger.info( "titulo "+storm_title)
			itemlist.append( Item(channel=__channel__,action="findvideos", server=item.server,fulltitle=storm_channel_name, title=storm_title, url=item.url , show=storm_show))
		else:
			if (DEBUG): logger.info( "episodios "+storm_channel_name)
			nitem=Item(channel=__channel__,url=item.url)
			#exec "import channels."+storm_channel_name+" as channel"
			try:
				exec "import channels."+storm_channel_name+" as channel"
			except:
				pass
			# El action nos devolvera el listado de capitulos (episodelist o episodios)
			try:
				exec "itemlist_p = channel."+action+"(nitem)"
				itemlist=itemlist_p
			except:
				pass
		for item in itemlist:
			patronchap="([0-9]{1,2}(x|X)[0-9]*)"
			matcheschap= re.compile(patronchap,re.DOTALL).findall(item.title)
			if (len(matcheschap)>0):
				episode=matcheschap[0][0].lower()
				if ((storm_channel_name=='seriesyonkis') or (storm_channel_name=='seriespepito')or (storm_channel_name=='vseries')):
					patronep= "([0-9]*)x([0-9]*)"
					matchesep=re.compile(patronep,re.DOTALL).findall(episode)
					if (len(matchesep[0][1])==1):
						episode=matchesep[0][0]+"x0"+matchesep[0][1]
				
			#else:
			#	episode="Sin numero"
				if (episode in dict.keys()):
					dict[episode]=dict[episode]+"*"+storm_channel_name+";"+item.url
				else:
					dict[episode]=storm_channel_name+";"+item.url

def directplay(item):
	path=config.get_data_path()+"stormtv/temp/"
	#download_path=config.get_download_path()
	download_path=config.get_setting("downloadpath")
	tvslang=stormlib.gettvslang(item.show)
	storm_chapter=item.extra
	storm_show=item.show
	
	verified_xml=path+storm_show+"_links_"+storm_chapter+"_"+tvslang+"_verified.xml"
	links = ET.parse(verified_xml)
	root=links.getroot()
	itemlist=[]
	verifiedlist=[]
	#comprobamos extensiones del fichero descargado
	downloaded1=download_path+"/"+storm_show+"_"+storm_chapter+".mp4"
	downloaded2=download_path+"/"+storm_show+"_"+storm_chapter+".flv"
	
	
	if os.path.exists(downloaded1):
		verifiedlist.append(Item(channel=__channel__,action="play_file",thumbnail=STATIC_SERVER+"vista.jpg",title=downloaded1,url="",fanart=STATIC_SERVER+"logo.jpg",show=storm_show,extra=storm_chapter,server="local",folder=False))
		if (DEBUG): logger.info( "downloaded:"+downloaded1)
	if os.path.exists(downloaded2):
		verifiedlist.append(Item(channel=__channel__,action="play_file",thumbnail=STATIC_SERVER+"vista.jpg",title=downloaded2,url="",fanart=STATIC_SERVER+"logo.jpg",show=storm_show,extra=storm_chapter,server="local",folder=False))
		if (DEBUG): logger.info( "downloaded:"+downloaded2)
	for link in root.findall('Link'):
		try:
			xlang=link.find('Lang').text
			channel=link.find("Channel").text
			server=link.find("Server").text
			url=link.find("Url").text
			surl=url.replace("&","&amp;")	
			verifiedlist.append(Item(channel=__channel__, action="play" , fulltitle=channel,title='[Verificado]'+tvslang+' '+server+" "+channel,url=surl,show=storm_show,extra=storm_chapter,server=server,folder=False))
		except:
			exc_type, exc_value, exc_traceback = sys.exc_info()
			pass
	itemlist.append(Item(channel=__channel__, action="forcefind" , title="[Volver a buscar] "+storm_chapter,fulltitle=storm_chapter,show=item.show,extra="0"))
	itemlist=itemlist+verifiedlist
	return itemlist
def play_file(item):
	storm_show=item.show
	storm_chapter=item.extra
	import xbmc
	if (DEBUG): logger.info( "[stormtv.py] play file ############")
	if (item.server=="local"):
		playlist = xbmc.PlayList( xbmc.PLAYLIST_VIDEO )
		playlist.clear()
		playlist.add(item.title)
		xbmc.Player().play( playlist)
		stormlib.setwatched(storm_show,storm_chapter)
		stormlib.xmlsetactive(storm_show)
		stormlib.xmlsetwatched(storm_show,storm_chapter)
	else:
		if (DEBUG): logger.info( "no es un fichero")
	return
			
	
def play(item):
	serverlist=["seriesyonkis","animeflv","shurweb","divxatope","seriesflv","animeid","seriesdanko","cinetux","cinehanwer","zpeliculas","sintonizzate","bricocine","oranline","newpct1","seriesadicto"]
	logger.info("[stormtv.py] Play"+item.show+","+item.extra+","+item.url)
	storm_fanart=item.fanart
	storm_plot=item.plot
	storm_thumbnail=item.thumbnail
	storm_chapter=item.extra
	storm_show=item.show
	storm_channel_name=item.fulltitle
	storm_title=item.title
	action="play"
	itemlist=[]
	res=True
	if "Verificado" not in item.title:
		if (DEBUG): logger.info( "play->process:"+ item.url)
		try:
			exec "import servers."+item.server+" as tserver"
			data =scrapertools.cache_page(item.url)
			#if (DEBUG): logger.info( data)
			find_url= tserver.find_videos(data)
			if (DEBUG): logger.info( "URL------------>"+find_url[0][1])
			s_url=find_url[0][1]
			res,test= tserver.test_video_exists(find_url[0][1])
			item_storm=Item(channel=__channel__,url=s_url,server=item.server,title=item.title, thumbnail=item.thumbnail, plot=item.plot)
		except:
			#if (DEBUG): logger.info( "[stormtv.py] Verified fallo test_video_exist "+vserver)
			res=False
	else:
		item_storm=Item(channel=__channel__,url=item.url,server=item.server,title=item.title, thumbnail=item.thumbnail, plot=item.plot)
	if ((config.get_setting("stormtvaccount")=="true")and(res==True)):
		from core import stormlib
		stormlib.setwatched(storm_show,storm_chapter)
		stormlib.xmlsetactive(storm_show)
		stormlib.xmlsetwatched(storm_show,storm_chapter)
		itemlist.append(Item(channel="shurweb", server=item.server, url=item_storm.url, category=item.category, title=item.title, thumbnail=item.thumbnail, plot=item.plot,  extra=item.extra, subtitle=item.subtitle,  fulltitle=item.fulltitle))
	return itemlist					

####################################################################################
# Esta funcion nos servirá para adecuar la salida de los distintos canales a una   #
# salida estandarizada para el plugin
####################################################################################
def transform(channel,show,fanart,thumbnail,chapter,slang,itemlist):
	storm_itemlist=[]
	
	for item in itemlist:
		storm_url=item.url
		storm_title=item.title
		if (DEBUG): logger.info( "Transform titel"+item.title)
		if (channel=="seriesdanko"):
			if (DEBUG): logger.info( "[stormlib] transform "+item.thumbnail+" "+item.title)
			img=item.thumbnail.split("/")
			img=img[len(img)-1]
			server=img.split(".")[0]
			if (server=="uploaded"):
				server="uploadedto"
			if (server=="played"):
				server="playedto"
			storm_title=item.title+"<"+server+">"
		if (channel=="divxatope"):
			patron="(.*) Temp ([0-9]*) cap ([0-9]*)"
			matches=re.compile(patron,re.DOTALL).findall(storm_title)
			for title,season,episode in matches:
				storm_title=title+" "+season+"x"+episode
		if (channel=="bricocine"):
			storm_title=item.title+" torrent"
		if (channel=="animeflv_me"):
			storm_title="directo "+item.title
		if (channel=="seriesyonkis"):
			storm_title=item.title.replace("uploaded.net", "uploadedto")
		if (channel=="cinetux"):
			storm_title=item.title.replace(" played ", " playedto ")
			storm_title=item.title.replace("uploaded.to", "uploadedto")
		if (channel=="oranline"):
			storm_title=item.title.replace("uploaded.to", "uploadedto")
		if (channel=="seriesflv"):
			storm_title=item.title.replace(" ul ", " uploadedto ")
			storm_title=item.title.replace(" streamin ", " streaminto ")
			storm_url=item.url+";"+item.extra
		if (channel=="seriespepito"):
			storm_title=item.title.replace(" ul ", " uploadedto ")
			storm_url=item.url+";"+item.extra
			
			if ("lang/es.png" in item.thumbnail):
					storm_title=item.title+"(SPA)"
			if ("lang/lat.png" in item.thumbnail):
					storm_title=item.title+"(LAT)"
			if ("lang/sub.png" in item.thumbnail):
					storm_title=item.title+"(VOS)"
		if (channel=="seriesblanco"):
			storm_title=item.title.replace(" uploaded ", " uploadedto ")
			storm_title=item.title.replace(" streamin ", " streaminto ")
			storm_url=item.url+";"+item.extra
		if (channel=="mejortorrent"):
			storm_url=item.url+";"+item.extra
		if (channel=="newpct1"):
			storm_title=item.title.replace("Descarga", "")
			storm_title+=" "+slang
		if (channel=="enlacia"):
			storm_title=item.title.replace("uploaded", "uploadedto")
			patron_chap='Temporada:Temporada ([1-9]) - Cap?tulo: ([1-9])'
			matches_chap = re.compile(patron_chap,re.DOTALL).findall(item.title)
			if (len(matches_chap)>0):
				storm_title=matches_chap[0][0]+"x"+matches_chap[0][1]
		if (channel=="vseries"):
			storm_url=vserie_url(item.url)
			storm_title=item.title.replace("ul", "uploadedto")
		storm_title=storm_title+"<"+channel.encode('utf-8')+">"
		#if (DEBUG): logger.info( "Transform title"+storm_title)
		storm_itemlist.append( Item(channel=__channel__, action="play" , title=storm_title, fulltitle=channel , url=storm_url, thumbnail=thumbnail, folder=False, fanart=fanart,show = show,extra=chapter))
	return storm_itemlist

	
	
###########################################################################################
####	Inteligence part !!!!!!!!!!!!! GOOOOO!!!
###########################################################################################
####
####  Actualiza las temporadas y capitulos, y busca los enlaces de los siguientes capitulos
####

def update_stormseries(item):
		import xbmc,sys
		user_id = config.get_setting("stormtvuser")
		user_pass = config.get_setting("stormtvpassword")
		path=config.get_data_path()+"stormtv/temp/"
		stormlib.getpages()
		view="Tvseries"
		f = open (path+"kk.txt", "a")
		i = datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
		#os.system('echo "Inicio Update Storm Series'+i+'" >>'+path+'cacheserie.txt')
		f.write("Inicio Update Storm Series "+i+"\n")
		if not os.path.exists(path):
			logger.info ("[stormtv.py]Creating data_path "+path)
			try:
				mkdir_p(path)
			except:
				logger.info("[stormtv.py] Mainlist  Fallo crear directorio")
				pass
		urllib.urlretrieve (SERVER+"tvseries/following/user/"+user_id+"/pass/"+user_pass+"/view/"+view, path+"following.xml")
		xml=path+"/"+"following.xml"
		tvserie = ET.parse(xml)
		series=tvserie.getroot()
		itemlist=[]
		today=datetime.date.today()
		previous_updated_date= ""
		last_watched_text=""
		j=1
		m=series.findall('serie')
		cuantas=str(len(m))
		f.write("Total de series a actualizar:"+cuantas)
		for serie in m:
			id = serie.find('id').text
			tvshow=path+id+".xml"
			type = serie.find('type').text
			tvserie = ET.ElementTree(serie)
			tvserie.write(tvshow)
			f.write("Actualizando serie "+str(j)+" de "+cuantas+"\n")
			j+=1
			if (type=="1"):
				#no hacemos nada si es una pelicula(de momento)
				if (DEBUG): logger.info( "movie" )
			else:
				update_xml = path+id+"_updates.xml"
				if (DEBUG): logger.info( "hash nuevo"+update_xml)
				if os.path.exists(update_xml):
					userie = ET.parse(update_xml)
					uroot = userie.getroot()
					try:
						update_scheduled = uroot.find('update_scheduled')
						update_scheduled_text = update_scheduled.text
					except:
						update_scheduled = "d"
					try:
						last_watched = uroot.find('last_watched')
						last_watched_text = last_watched.text
					except:
						last_watched = ""
					try:
						last_checked = uroot.find('last_checked')
						last_checked_text = last_checked.text
						if (DEBUG): logger.info( "[stormtv.py] modify_updatexml "+last_checked_text+ "fue la ultima vez que se comprobó")
						f.write("[stormtv.py] modify_updatexml "+last_checked_text+ "fue la ultima vez que se comprobó")
						try:
							last_checked_date = datetime.datetime.strptime(last_checked_text+" 00:00", "%Y-%m-%d %M:%S")
						except:
							last_checked_date = datetime.datetime(*(strptime(last_checked_text+" 00:00", "%Y-%m-%d %M:%S")[0:6]))
					except:
						last_checked_text = ""
						
					#
					#Deteccion de actualizacion de una serie
					#
					update_now='0'
					today=datetime.date.today()
					if (update_scheduled_text == 'd'):
							update_now='1'
					elif (update_scheduled_text == 'w'):
						since_week = last_checked_date + datetime.timedelta(weeks=1)
						if (today >= since_week.date()):
							update_now='1'
							if (DEBUG): logger.info( "[stormtv.py] update_storm_series Toca actualizar la serie")
							f.write("[stormtv.py] update_storm_series Toca actualizar la serie"+"\n")
						else:
							update_now='0'
							if (DEBUG): logger.info( "[stormtv.py] update_storm_series No toca actualizar la serie")
							f.write("[stormtv.py] update_storm_series No toca actualizar la serie"+"\n")
					elif (update_scheduled_text == 'm'):
						since_month = last_checked_date + datetime.timedelta(weeks=4)
						if (today >= since_month.date()):
							update_now='1'
							if (DEBUG): logger.info( "[stormtv.py] update_storm_series Toca actualizar la serie")
							f.write("[stormtv.py] update_storm_series Toca actualizar la serie"+"\n")
						else:
							update_now='0'
							if (DEBUG): logger.info( "[stormtv.py] update_storm_series No toca actualizar la serie")
							f.write("[stormtv.py] update_storm_series No toca actualizar la serie"+"\n")
					if (update_now == '1'):
						conceptseason(Item(show=id,extra="1"))
						modify_updatexml(id)
					else:
						if (DEBUG): logger.info( "No ha llegado el momento de actualizar"+id)
						f.write("No ha llegado el momento de actualizar"+id+"\n")
				#Si no existe el fichero update es que no se ha ejecutado nunca conceptseason, por lo que se lanza
				else:
					
					conceptseason(Item(show=id))
				
					if (DEBUG): logger.info("lalala")
		
			try:
				#os.system('echo "Inicio Cacheo Serie '+id+'">>'+path+'cacheserie.txt')
				f.write("Inicio Cacheo Serie "+id+"\n")
				cache_links(id,"")
				#os.system('echo "Fin Cacheo Serie '+id+'">>'+path+'cacheserie.txt')
				f.write("Fin Cacheo Serie "+id+"\n")
			except:
				#os.system('echo "Errrooorr">>'+path+'cacheserie.txt')
				f.write("Error cacheo "+id)
		i = datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
		#os.system('echo "Fin Update Storm Series'+i+'" >>'+path+'cacheserie.txt')
		f.write("Fin Update Storm Series"+i+"\n")
		f.close()

####
#### Devuelve los items de los siguientes capitulos de un show
####		
def next_chapters(id):
	tvslang=stormlib.getverifylang()
	path=config.get_data_path()+"stormtv/temp/"
	last_watched=""
	itemlist=[]
	tvslang=stormlib.gettvslang(id)
	vistos_list=stormlib.getwatched(id)
	vistos=str(len(vistos_list))
	try:
		last_watched=sorted(vistos_list.keys())[-1]
		if (DEBUG): logger.info( "[Next_chapters] last_watched"+last_watched)
	except:
		last_watched=""
	last_verified=last_watched
	title=""
	start=0
	cache_number=3
	
	if (last_verified<>""):
		sea,chap=stormlib.seachap(last_verified)
		if (int(chap)+1<10):
			chapter="0"+str(int(chap)+1)
		else:
			chapter=str(int(chap)+1)
		next_verified=sea+"x"+chapter
		if (DEBUG): logger.info( "[stormtv.py] cache_links next_verified:"+next_verified+"#"+path+"#"+id+"#" )
		if os.path.exists(path+id+"_chapters.xml"):
			tvserie = ET.parse(path+id+"_chapters.xml")
			root=tvserie.getroot()
			episodes=root.findall("Episode")
			for episode in episodes:
				if (episode.get('number')==next_verified):
					start=1
				if (start==1):
					if (DEBUG): logger.info( "[stormtv.py] cache_links start:"+str(start))
					
					if (episode.get('watched') =="True"):
							title=episode.get('number')+" [COLOR green][Visto][/COLOR]"
					else:
							title=episode.get('number')
							fulltitle=episode.get('number')
							if os.path.exists(path+id+"_links_"+title+"_"+tvslang+"_verified.xml"):
								title=title + " ¡¡"+tvslang.upper()+"!!"
							itemlist.append(Item(channel=__channel__, action="conceptfind" , title=title, fulltitle=fulltitle , show=id,extra="0"))
					
					cache_number-=1
				if (cache_number==0):
					break
	return itemlist
#####
#
# Borra los ficheros descargados que se han visto salvo el ultimo.
#
####
def delete_watched(id,last_watched):
	path=config.get_data_path()+"stormtv/temp/"
	#download_path=config.get_download_path()
	download_path=config.get_setting("downloadpath")
	f = open (path+"delete_watched.txt", "a")
	i = datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
	f.write(i+" Borrado de ficheros de la serie:" +id+"\n")
	tvslang=stormlib.gettvslang(id)
	cache_number=5
	last_verified=last_watched
	start=0
	itemlist=[]
	if (last_watched==""):
		vistos_list=stormlib.getwatched(id)
		vistos=str(len(vistos_list))
		#try:
		last_watched=sorted(vistos_list.keys())[-1]
		#os.system('echo "last_watched '+last_watched+'">>'+path+'cacheserie.txt')
		#except:
		#	last_watched="1x00"
	last_verified=last_watched
	for key in sorted(vistos_list.keys()):
		if (key<>last_watched):
			file1=download_path+"/"+id+"_"+key+".mp4"
			file2=download_path+"/"+id+"_"+key+".flv"
			#if (DEBUG): logger.info( file1 )
			#if (DEBUG): logger.info( file2 )
			if (os.path.exists(file1)):
				os.remove(file1)
				
				f.write(" Borrado de ficheros de la serie:" +file1+"\n")
			if (os.path.exists(file2)):
				f.write(" Borrado de ficheros de la serie:" +file2+"\n")
				os.remove(file2)
	i = datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
	f.write(i+" Fin Borrado de ficheros de la serie:" +id+"\n")
	f.close()
####
####  Buscamos los enlaces de los 5 siguientes capitulos  ####
####	
def cache_links(id,last_watched):
	path=config.get_data_path()+"stormtv/temp/"
	f = open (path+"cache_links.txt", "a")
	i = datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
	#os.system('echo "Inicio Update Storm Series'+i+'" >>'+path+'cacheserie.txt')
	f.write(i+" Inicio Cache Links Serie:" +id+"\n")
	tvslang=stormlib.gettvslang(id)
	cache_number=5
	last_verified=last_watched
	start=0
	itemlist=[]
	if (last_watched==""):
		vistos_list=stormlib.getwatched(id)
		vistos=str(len(vistos_list))
		#try:
		last_watched=sorted(vistos_list.keys())[-1]
		#os.system('echo "last_watched '+last_watched+'">>'+path+'cacheserie.txt')
		#except:
		#	last_watched="1x00"
	last_verified=last_watched
	if (DEBUG): logger.info( "####"+last_verified+"####")
	f.write("Ultimo capitulo visto:" +last_verified+"\n")
	if (last_verified<>""):
		sea,chap=stormlib.seachap(last_verified)
		if (int(chap)+1<10):
			chapter="0"+str(int(chap)+1)
		else:
			chapter=str(int(chap)+1)
		next_verified=sea+"x"+chapter
		if (DEBUG): logger.info( "[stormtv.py] cache_links next_verified:"+next_verified)
		f.write("Siguiente capitulo a comprobar:" +next_verified+"\n")
		if os.path.exists(path+id+"_chapters.xml"):
			
			tvserie = ET.parse(path+id+"_chapters.xml")
			root=tvserie.getroot()
			episodes=root.findall("Episode")
			for episode in episodes:
				if (episode.get('number')==next_verified):
					start=1
				if (start==1):
					if (DEBUG): logger.info( "[stormtv.py] cache_links start:"+str(start))
					try:
						isverified=episode.get("verified")
						if (isverified<>"True")and(not os.path.exists(path+id+"_links_"+episode.get('number')+"_"+tvslang+"_verified.xml")):
							f.write("Verificando el capitulo:" +episode.get('number')+" ya que no se ha verificado y no existe el fichero"+id+"_links_"+episode.get('number')+"_"+tvslang+"_verified.xml"+"\n")
							itemlist=conceptfind(Item(show=id,extra="0",fulltitle=episode.get('number')))
							cache_verify(Item(show=id,extra=episode.get('number'),title=tvslang))
							episode.set("verified","True")
							
						else:
							f.write("El capitulo:" +episode.get('number')+" ya se ha verificado\n")
							if (DEBUG): logger.info( "este capitulo ya se ha buscado")
					except:
						if (not os.path.exists(path+id+"_links_"+episode.get('number')+"_"+tvslang+"_verified.xml")):
							f.write("[Exception] Verificando el capitulo:" +episode.get('number')+" ya que no existe el fichero"+id+"_links_"+episode.get('number')+"_"+tvslang+"_verified.xml"+"\n")
							if (DEBUG): logger.info( "[stormtv.py] cache_links Exception")
							conceptfind(Item(show=id,extra="0",fulltitle=episode.get('number')))
							cache_verify(Item(show=id,extra=episode.get('number'),title=tvslang))
						else:
							episode.set("verified","True")
					cache_number-=1
				if (cache_number==0):
					break
		else:
			f.write("[Error] No existe el fichero:" +path+id+"_chapters.xml\n")
		tvserie.write(path+id+"_chapters.xml")
	f.close()

####
####  Creamos el fichero de update  ####
####
def create_updatexml(id,sea_dict):
	path=config.get_data_path()+"stormtv/temp/"
	update_xml = path+id+"_updates.xml"
	sea_keys = sea_dict.keys()
	sea_keys.sort()
	seasons=""
	for key in sea_keys:
		if (seasons==""):
			seasons+=str(key)
		else:
			seasons+=","+str(key)
	if os.path.exists(path+id+"_chapters.xml"):
		logger.info("[stormtv.py] create_updatexml")
		chapter = ET.parse(path+id+"_chapters.xml")
		root_chapter=chapter.getroot()
		episodes=root_chapter.findall('Episode')
		total_chapter=str(len(episodes))
		today=datetime.date.today()
		last_updated_text = today.strftime("%Y-%m-%d")
		vistos_list=stormlib.getwatched(id)
		vistos=str(len(vistos_list))
		try:
			last_watched=vistos_list.keys()[-1]
		except:
			last_watched=""
		userie = ET.Element('serie')                     
		userie.append(ET.fromstring('<type>0</type>'))
		userie.append(ET.fromstring('<id>'+id+'</id>'))
		userie.append(ET.fromstring('<watched>'+vistos+'</watched>'))
		userie.append(ET.fromstring('<last_watched>'+last_watched+'</last_watched>'))
		userie.append(ET.fromstring('<chapters>'+total_chapter+'</chapters>'))
		userie.append(ET.fromstring('<previous_chapters>'+total_chapter+'</previous_chapters>'))
		userie.append(ET.fromstring('<last_updated>'+last_updated_text+'</last_updated>'))
		userie.append(ET.fromstring('<last_checked>'+last_updated_text+'</last_checked>'))
		userie.append(ET.fromstring('<previous_updated>'+last_updated_text+'</previous_updated>'))
		userie.append(ET.fromstring('<update_scheduled>d</update_scheduled>'))
		update_serie = ET.ElementTree(userie)
		update_serie.write(update_xml)
	else:
		logger.info("[stormtv.py] create_updatexml no se ha podido crear el fichero _updates.xml")

####
####  Modificamos el fichero de update  ####
####
def modify_updatexml(id):
	path=config.get_data_path()+"stormtv/temp/"
	update_xml = path+id+"_updates.xml"
	chapters_xml = path+id+"_chapters.xml"
	today=datetime.date.today()
	if os.path.exists(chapters_xml):
		logger.info("[stormtv.py] modify_updatexml")
		chapter = ET.parse(chapters_xml)
		root_chapter=chapter.getroot()
		total_chapter=str(len(root_chapter.findall('Episode')))
	else:
		total_chapter=""
	if os.path.exists(update_xml):
		userie = ET.parse(update_xml)
		uroot = userie.getroot()
		try:
			update_scheduled = uroot.find('update_scheduled')
			update_scheduled_text = update_scheduled.text
		except:
			update_scheduled = ""
		try:
			last_checked = uroot.find('last_checked')
			last_checked_text = last_checked.text
			if (DEBUG): logger.info( "[stormtv.py] modify_updatexml "+last_checked_text+ "fue la ultima vez que se comprobó")
			try:
				last_checked_date = datetime.datetime.strptime(last_checked_text+" 00:00", "%Y-%m-%d %M:%S")
			except:
				last_checked_date = datetime.datetime(*(strptime(last_checked_text+" 00:00", "%Y-%m-%d %M:%S")[0:6]))
		except:
			last_checked_text = ""
		try:
			last_updated = uroot.find('last_updated')
			last_updated_text = last_updated.text
		except:
			last_updated_text = ""
		try:
			chapters = uroot.find('chapters')
			chapters_text = chapters.text
		except:
			chapters_text = ""
		try:
			previous_chapters = uroot.find('previous_chapters')
			previous_chapters_text = previous_chapters.text
		except:
			previous_chapters_text = ""
					
		try:
			previous_updated = uroot.find('previous_updated')
			previous_updated_text = previous_updated.text
			if (DEBUG): logger.info( previous_updated_text+ "fue la ultima vez con cambios")
			try:
				previous_updated_date = datetime.datetime.strptime(previous_updated_text+" 00:00", "%Y-%m-%d %M:%S")
			except:
				previous_updated_date = datetime.datetime(*(strptime(previous_updated_text+" 00:00", "%Y-%m-%d %M:%S")[0:6]))
		except:
			previous_updated_text = ""
		week_update_date = today - datetime.timedelta(weeks=1)
		month_update_date = today - datetime.timedelta(weeks=4)
		if (previous_chapters_text == total_chapter):
			if (DEBUG): logger.info( "[stormtv.py] modify_updatexml No hay capitulos nuevos")
			if ((update_scheduled_text=='d') and (week_update_date>previous_updated_date.date())):
				update_scheduled.text='w'
				if (DEBUG): logger.info( "Programacion cambiada de diaria a Semanal")
			elif ((update_scheduled_text=='w')and (month_update_date>previous_updated_date.date())):
				update_scheduled.text='m'
				if (DEBUG): logger.info( "Programacion cambiada de Semana a Mensual")
		else:
			if (DEBUG): logger.info( "[stormtv.py] modify_updatexml Si hay capitulos nuevos")
			previous_updated.text = last_updated.text
			last_updated.text = today.strftime("%Y-%m-%d")
			previous_chapters.text = chapters_text
			chapters.text = total_chapter
			if ((update_scheduled_text=='m')and (month_update_date<=previous_updated_date.date())):
				update_scheduled.text='w'
				if (DEBUG): logger.info( "[stormtv.py] modify_updatexml Programacion cambiada de Mensual a Semanal")
			elif ((update_scheduled_text=='w')and (week_update_date<=previous_updated_date.date())):
				update_scheduled.text='d'
				if (DEBUG): logger.info( "[stormtv.py] modify_updatexml Programacion cambiada de Semanal a diaria")
		last_checked_text=today.strftime("%Y-%m-%d")
		last_checked.text=last_checked_text
		userie.write(update_xml)
		
####
####  Forzamos la actualizacion de la serie  ####
####
def update_serie(item):
		import xbmc,sys
		storm_show=item.show
		user_id = config.get_setting("stormtvuser")
		user_pass = config.get_setting("stormtvpassword")
		path=config.get_data_path()+"stormtv/temp/"
		view="Tvseries"
		urllib.urlretrieve (SERVER+"tvseries/following/user/"+user_id+"/pass/"+user_pass+"/view/"+view, path+"following.xml")
		xml=path+"/"+"following.xml"
		tvserie = ET.parse(xml)
		series=tvserie.getroot()
		itemlist=[]
		today=datetime.date.today()
		previous_updated_date= ""
		for serie in series.findall('serie'):
			id = serie.find('id').text
			if (id==storm_show):
				tvshow=path+id+".xml"
				type = serie.find('type').text
				tvserie = ET.ElementTree(serie)
				tvserie.write(tvshow)
		
				if (type=="1"):
					#no hacemos nada si es una pelicula(de momento)
					if (DEBUG): logger.info( "movie")
				else:
					update_xml = path+id+"_updates.xml"
					if (DEBUG): logger.info( "hash nuevo"+update_xml)
					conceptseason(Item(show=id,extra="1"))
					if os.path.exists(path+id+"_chapters.xml"):
						if not os.path.exists(update_xml):
							create_updatexml(id)
						else:
							modify_updatexml(id)
					else:
						if (DEBUG): logger.info( " no se ha podido generar.")
					if (DEBUG): logger.info("lalala")
					
					
def create_directory(path):
	if not os.path.exists(path):
		logger.info("[stormtv.py] create_directory "+path)
		try:
			os.mkdirs(path)
			logger.info( "[stormtv.py] create_directory Se ha creado el directorio correctamente" )
			logger.info( "[stormtv.py] create_directory Se ha creado el directorio correctamente" )
		except:
			logger.info( "[stormtv.py] create_directory fallo crear directorio" )
			pass
	else:
		logger.info( "[stormtv.py] create_directory el directory ya existe" )

def remove_tempxml(path):
	for f in os.listdir(path): 
		if f.endswith(".xml"): 
			os.remove(os.path.join(path,f))

def mkdir_p(path):
    try:
           os.makedirs(path)
    except OSError , exc:
           if exc.errno == errno.EEXIST and os.path.isdir(path):
              pass
           else: raise
def download_all_next(item):
	path=config.get_data_path()+"stormtv/temp/"
	xml=path+"activeseries.xml"
	tvserie = ET.parse(xml)
	series=tvserie.getroot()
	for serie in series.findall('serie'):
		id = serie.find('id').text
		type = serie.find('type').text
		download_next(Item(channel=__channel__,action="download_next",thumbnail=STATIC_SERVER+"vista.jpg",title="download next",url="",fanart=STATIC_SERVER+"logo.jpg",show=id))
	return
def delete_all_watched(item):
	path=config.get_data_path()+"stormtv/temp/"
	xml=path+"activeseries.xml"
	tvserie = ET.parse(xml)
	series=tvserie.getroot()
	for serie in series.findall('serie'):
		id = serie.find('id').text
		type = serie.find('type').text
		delete_watched(id,"")
	return
def download_next(item):
	import xbmc
	from core import downloadtools
	path=config.get_data_path()+"stormtv/temp/"
	tvslang=stormlib.gettvslang(item.show)
	id=item.show
	itemlist=[]
	linklist=[]
	itemlist=next_chapters(item.show)
	xml=path+id+"_chapters.xml"
	tvserie = ET.parse(xml)
	root=tvserie.getroot()
	serverlist=["streamcloud","powvideo","nowvideo"]
	for item in itemlist:
		if (DEBUG): logger.info( "[stormtv.py] download_next chapter "+item.fulltitle)
		verified=path+id+"_links_"+item.fulltitle+"_"+tvslang+"_verified.xml"
		channels=root.find("Episode[@number='"+item.fulltitle+"']")
		try:
			downloaded=channels.get('downloaded')
		except:
			downloaded='False'
		if os.path.exists(verified) and (downloaded<>'True'):
			if (DEBUG): logger.info( "[stormtv.py] download_next chapter"+item.fulltitle)
			linklist=directplay(Item(channel=__channel__, show=item.show,extra=item.fulltitle))
			for link in linklist:
				downsucess="False"
				if ((link.server in serverlist) and (downsucess=="False")):
					#link.server="streamcloud"
					#link.url="http://streamcloud.eu/3snun5k3cq68"
					if (DEBUG): logger.info( "[stormtv.py] download_next "+link.server)
					if (DEBUG): logger.info( "[stormtv.py] download_next "+link.url)
					try:
						video_urls,puedes,motivo = servertools.resolve_video_urls_for_playing(link.server,link.url,"",False)
						# El vídeo de más calidad es el último
						if (video_urls<>""):
							mediaurl = video_urls[len(video_urls)-1][1]
							title = id+"_"+item.fulltitle
							devuelve = downloadtools.downloadbest(video_urls,title)
							#devuelve=0
							if devuelve==0:
								stormlib.xmlsetdownloaded(id,item.fulltitle)
								#advertencia = xbmcgui.Dialog()
								#Comprobar tamanyo del fichero
								#resultado = advertencia.ok("plugin" , "Descargado con éxito")
								downsucess="True"
							elif devuelve==-1:
								advertencia = xbmcgui.Dialog()
								resultado = advertencia.ok("plugin" , "Descarga abortada")
							else:
								advertencia = xbmcgui.Dialog()
								resultado = advertencia.ok("plugin" , "Error en la descarga")
						else:
							if (DEBUG): logger.info( "Fallo a descargar fichero" )
					except:
						pass
					
	return
	#downloadfile(url,nombrefichero,headers=[],silent=False,continuar=False)
		   
def force_decode(string):
		if (DEBUG): logger.info( "force_decode"+string )
		try:
			if (DEBUG): logger.info( "utf-8" )
			kk=string.decode('utf-8')
			kk2=kk.encode('ascii','xmlcharrefreplace')
			if (DEBUG): logger.info( kk2 )
			return kk2
		except:
			try:
				if (DEBUG): logger.info( "latin-1" )
				kk=string.decode('latin-1')
				kk2=kk.encode('ascii','xmlcharrefreplace')
				if (DEBUG): logger.info( kk2 )
				return kk2
				
			except:
				try:
					if (DEBUG): logger.info( "ISO-8859-1")
					kk=string.decode('iso-8859-1')
					kk2=kk.encode('ascii','xmlcharrefreplace')
					if (DEBUG): logger.info( kk2 )
					return kk2
				except:
					if (DEBUG): logger.info( "otro encoding")
def replace_acent(string):
	string=string.replace("&#193;", "A")
	string=string.replace("&Aacute;", "A")
	string=string.replace("&#225;", "a")
	string=string.replace("&aacute;", "a")
	string=string.replace("&#201;", "E")
	string=string.replace("&Eacute;", "E")
	string=string.replace("&#233;", "e")
	string=string.replace("&eacute;", "e")
	string=string.replace("&#205;", "I")
	string=string.replace("&Iacute;", "I")
	string=string.replace("&#237;", "i")
	string=string.replace("&iacute;", "i")
	string=string.replace("&#211;", "O")
	string=string.replace("&Oacute;", "O")
	string=string.replace("&#243;", "o")
	string=string.replace("&oacute;", "o")
	string=string.replace("&#218;", "U")
	string=string.replace("&Uacute;", "U")
	string=string.replace("&#250;", "u")
	string=string.replace("&uacute;", "u")
	string=string.replace("&Ntilde;", "Ñ")
	string=string.replace("&ntilde;", "ñ")
	string=string.replace("&Uuml;","Ü")
	string=string.replace("&uuml;","ü")
	
	return string

def test():
    from servers import servertools

    # mainlist
    mainlist_items = mainlist(Item())
    # Da por bueno el canal si alguno de los vídeos de "Novedades" devuelve mirrors
    episode_items = lastepisodes(mainlist_items[0])
    bien = False
    for episode_item in episode_items:
        mediaurls = findvideos( episode_item )
        if len(mediaurls)>0:
            return True

    return False
def vserie_url(url):
	DEFAULT_HEADERS = []
	DEFAULT_HEADERS.append( ["User-Agent","Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.6; es-ES; rv:1.9.2.12) Gecko/20101026 Firefox/3.6.12"] )
	logger.info("pelisalacarta.channels.vseries url="+url)
	urlPartsList = url.split("/")
	i=0
	refer=""
	while (i<len(urlPartsList)-1):
		refer+=urlPartsList[i]+"/"
		i+=1
	if (DEBUG): logger.info( refer)
	extra=refer
	headers=DEFAULT_HEADERS[:]
	headers.append(["Referer",extra])
	if (DEBUG): logger.info( "headers item.extra "+extra )
	'''
	21:32:07 T:4560547840  NOTICE: 'GET /serie/104-1x01-sincronizado/temporada-1/capitulo-1/17088" rel="nofollow" target="_blank" class="btn btn-success HTTP/1.1\r\nAccept-Encoding: identity\r\nReferer: http://vserie.com/serie/104-1x01-sincronizado/temporada-1/capitulo-1\r\nHost: vserie.com\r\nCookie: PHPSESSID=fed3f2fbe02705b186646e0a5b4692b8\r\nConnection: close\r\nUser-Agent: Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.6; es-ES; rv:1.9.2.12) Gecko/20101026 Firefox/3.6.12\r\n\r\n'
	'''
	media_url = scrapertools.downloadpage(url,header_to_get="location",follow_redirects=False, headers=headers)
	logger.info("media_url="+media_url)
	return media_url
def new_concept(item):
	conn = sqlite3.connect(config.get_data_path()+"stormtv\stomtvdb.db")
	logger.info(config.get_data_path()+"stormtv\stomtvdb.db" )
	t = ('seriesblanco',)
	for row in conn.execute('SELECT * FROM channels WHERE ch_name=?', t):
		logger.info( "new_concept "+row[2])